-------------------------------------------------------------------------------
                             wxWidgets Change Log
-------------------------------------------------------------------------------

Note: This file contains the list of changes since wxWidgets 3.x, please see
      docs/changes_30.txt for the changes in the previous versions.


INCOMPATIBLE CHANGES SINCE 3.2.0
================================

While 3.2.x versions are not supposed to have any incompatible changes in
theory, this section describes such changes as they exist in practice:

- wxWidgets 3.2.4 added possibility to initialize wxArrayString and similar
  classes from std::initializer_list<>, which may introduce ambiguities in the
  existing code overloading some functions to take multiple classes implicitly
  constructible from initializer lists, e.g. std::vector<std::wxString> and
  wxArrayString. Such problems can be fixed by explicitly specifying the class
  to use but it is also possible to predefine wxNO_INITIALIZER_LIST to disable
  support for std::initializer_list<> in wxWidgets and fix compilation without
  modifying the application code. wxWidgets 3.2.8 extended initializer_list<>
  support to wxVector, so the same considerations apply to it too.


INCOMPATIBLE CHANGES SINCE 3.0.x:
=================================

Changes in behaviour not resulting in compilation errors
--------------------------------------------------------

- wxRegEx now uses PCRE library, changing the meaning of some regular
  expressions, please see the "Changes" section in wxRegEx documentation for
  more details.

- wxRibbonButtonBar::DeleteButton() now deletes and not just removes the button.

- Default interpolation mode in wxGDIPlusContext under MSW is now
  wxINTERPOLATION_DEFAULT and not wxINTERPOLATION_GOOD as in 3.0 for
  consistency with OS X, call SetInterpolationQuality() explicitly if needed.

- Calling wxYield() in wxMSW now generates wxEVT_IDLE events, just as in the
  other ports, but this can be unexpected for the applications not expecting
  their idle handlers to be called from inside wxYield().

- Creating wxBitmap with 0 width or height now always fails in all ports
  (it used to succeed in wxMSW).

- Using invalid flags with wxBoxSizer or wxGridSizer items now triggers asserts
  when done from the code or error messages when done in XRC. These asserts are
  best avoided by fixing the flags, but wxSizerFlags::DisableConsistencyChecks()
  can be used to globally suppress them until this can be done. Even less
  intrusively, environment variable WXSUPPRESS_SIZER_FLAGS_CHECK can be set (to
  any value) to achieve the same effect.

- wxWS_EX_VALIDATE_RECURSIVELY is now the default behaviour, i.e. calling
  Validate() or TransferData{From,To}Window() will now also call the same
  function for all children.

- wxOSX/Carbon port doesn't exist any more, wxOSX/Cocoa will be silently used
  instead even if configure --with-osx_carbon option is used.

- The pure virtual function wxAppTrait::GetToolkitVersion() now has a parameter
  for getting the micro version. If you override GetToolkitVersion() you need
  to add this new third parameter.

- wxWindow::CreateAccessible() doesn't return accessible object by default
  anymore and GetOrCreateAccessible() may return NULL, indicating that native
  system-provided accessibility should be used.

- wxMSW port doesn't always let the system process WM_SYSKEYDOWN events any
  more, make sure to call event.Skip() in your wxEVT_KEY_DOWN and/or wxEVT_CHAR
  event handlers if you want the standard key combinations such as Alt-Space or
  Alt-F4 to work.

- wxMSW port now uses better appearing but much slower pens for dotted and
  dashed lines. Use wxPenInfo::LowQuality() or wxPen::SetQuality() to return to
  the previous version behaviour and performance characteristics if you are
  drawing many lines using such pens.

- wxOSX port uses default button margins for wxBitmapButton by default, for
  consistency with the other ports. You now need to call SetMargins(0, 0)
  explicitly if you really don't want to have any margins in your buttons.

- wxEVT_AUINOTEBOOK_PAGE_CHANGED event is now sent after changing the page,
  as expected, and not before doing it.

- wxJoystickEvent::GetButtonChange() now returns "1 << N" for the events
  generated by the button number N under all platforms, whereas it used to
  return just "N" under Linux and macOS. Use the new GetButtonOrdinal() to
  update the existing code if necessary.

- Generic wxDataViewCtrl now always resizes its last column to fill all the
  available space, as the GTK+ version always did.

- wxGTK wxNotebook::AddPage() doesn't generate any events any more for the
  first page being added, for consistency with the other ports.

- wxGTK wxTextCtrl doesn't generate any wxEVT_TEXT when it's created with
  non-empty value, for consistency with the other ports.

- wxDC::GetTextExtent() returns height of 0 for empty string in wxGTK and wxOSX
  too now, for consistency with wxMSW and other kinds of wxDC.

- wxMSW wxToolBar height now adapts to the height of embedded controls, making
  the toolbar taller if necessary, rather than making the controls smaller. To
  return to the previous behaviour, you need to explicitly create controls of
  smaller size.

- wxDC::DrawCheckMark() draws the same shape under all platforms now, use the
  new wxRendererNative::DrawCheckMark() to draw MSW-specific themed check mark.

- wxTE_PROCESS_ENTER must be used to receive wxEVT_TEXT_ENTER events from even
  multiline wxTextCtrl, conforming to the documentation, but contrary to the
  previous behaviour in wxMSW, when these events were always generated in this
  case. Please add wxTE_PROCESS_ENTER style if you relied on the old behaviour.

- wxGLCanvas now uses physical pixels on high DPI displays under platforms
  where they're different from logical ones (wxGTK3, wxOSX). Multiply logical
  coordinates, e.g. returned by wxWindow::GetSize() by GetContentScaleFactor()
  before using them with OpenGL functions.

- wxGTK now uses wxID_NONE item ID for wxEVT_MENU_HIGHLIGHT events sent when
  there is no highlighted menu item, instead of wxID_ANY used before, for
  consistency with wxMSW.

- wxListCtrl::GetItemState() in wxMSW now checks the passed in item index for
  validity, as the generic version under the other platforms already did.

- wxAuiNotebook::RemovePage() now hides the removed page, so it needs to be
  shown again if it is reused in another place.

- wxSizer::RecalcSizes() shouldn't be called directly (note that it was never
  supposed to be called, only implemented), call Layout() instead.

- wxFileDialog::GetPath() and wxFileDialog::GetFilename() now assert and return
  an empty string if called on dialogs with the wxFD_MULTIPLE style.

- wxGetInstallPrefix() now returns wxString.

- wxChoice::GetString() now consistently asserts when passed an invalid index.

- wxSpinCtrlDouble now always resets its value to GetMin() if an invalid text
  string is passed to its SetValue(wxString) overload after its creation.

- wxSpinCtrl::SetValue(wxString) overload doesn't generate any events with
  wxMSW, which was already the documented behaviour.

- wxButton::GetBitmap{Current,Disabled,Focus,Pressed}() only return valid
  bitmaps in wxMSW if the corresponding Set had been called before, as in the
  other ports, instead of returning the normal bitmap as fallback in this case.

- wxFileName::GetVolume() now returns "\\share" and not just "share" for the
  UNC paths (i.e. \\share\path\on\remote\server) and "\\?\Volume{GUID}" for the
  volume GUID paths rather than just "Volume{GUID}" as before. This allows
  distinguishing them from the drive letters, even for single letter network
  share name.

- wxRichTextParagraph::GetLines() now returns const wxVector<wxRichTextLine*>&
  instead of wxList<wxRichTextLine*>&.

- wxDateTime::ParseRfc822Date() now interprets a 2-digit year as 19xx, or
  20xx for 00..29, whereas earlier e.g. 95 was interpreted literally as 95 AD.


Changes in behaviour which may result in build errors
-----------------------------------------------------

- wxBitmapComboBoxBase::SetItemBitmap() changed argument's type from wxBitmap
  to wxBitmapBundle.

- "webview" library is not included in `wx-config --libs` output any more, you
  need to request it explicitly, e.g. `wx-config --libs std,webview`.

- wxMSW now requires linking with a few more system libraries: oleacc.lib,
  shlwapi.lib, uxtheme.lib and version.lib.
  This is done automatically in most cases, but if you use a static build of
  the library with a non-MSVC compiler such as MinGW and do not use wx-config,
  then you will need to add these libraries to your make or project files
  yourself.

- wxPaintEvent objects can no longer be created by the application code. This
  was never supposed to work and is now forbidden at compile-time instead of
  resulting in errors during run-time.

- WXWIN_OS_DESCRIPTION doesn't exist any longer, use wxGetOsDescription().

- Never documented and not always available private wxGetClipboardData()
  function now doesn't exist at all any more in wxMSW, use wxClipboard instead.

- wxGraphicsRenderer::CreatePen() now takes wxGraphicsPenInfo and not a wxPen.
  This only affects code defining its own custom renderers, code just using
  wxGraphicsContext::CreatePen() continues to compile and work as before.

- wx/treebook.h doesn't include wx/treectrl.h (and, via it, wx/textctrl.h) any
  more, include these headers explicitly from your code if necessary.

- wxHtmlDCRenderer::Render() arguments have changed, simply omit the ones not
  existing in the function signature any more to update the code using it.

- wxHtmlCell::AdjustPagebreak() has lost its "known_pagebreaks" argument,
  update your code if you override this method (you shouldn't be calling it).

- wxListCtrl::SetItem() overload taking the column index now returns bool and
  not long. Its return value hasn't changed, however, and is still always
  either true or false, so normally the existing code should continue to work.

- configure only accepts the options it knows about now and doesn't silently
  ignore all the rest. If you get errors about unknown options, you may either
  specify --disable-option-checking argument to continue accepting them (which
  only ever makes sense if you pass these options to sub-configure scripts) or,
  e.g. if the error is due to spelling an option name wrongly, fixing or
  removing its name.

- wxTextValidator::Get{In,Ex}cludes() now return a const reference to
  wxArrayString. Please update your code to use the appropriate setter
  Set[Char]{In,Ex}cludes(), instead of mutating the internal data directly.

- Under macOS, 10.11 SDK is the minimum SDK, building and deploying under 10.10.5 and
  higher is supported, you must use at least Xcode 7.2.1.

- wxOSX Xcode projects no longer include the i386 target by default and,
  with Xcode 12 or later, build for the arm64 architecture in addition to
  existing x86_64. See build/osx/wxcocoa.xcconfig for more information.

- wxPGProperty ctors are not longer public since this class is intended to be
  a base class and should not be instantiated directly.

- wxIntProperty::DoValidation() and wxFloatProperty::DoValidation() are
  no longer public since they are helpers intended for internal use only.

- wxGridCellAttr ctor taking wxGridCellAttr pointer is now explicit.

- wxAuiPaneButton doesn't exist any more, it was never supposed to be used
  outside of the library, but if you did use, just use "int" button instead.

- wxAuiMDIChildFrame now inherits from wxFrame and not wxPanel, you will need
  to change your code and XRC definitions accordingly.

- wxGridEvent methods GetRow() and GetCol() are no longer virtual.

- wxImage constructor from XPM data is now explicit, write "wxImage(xpmData)"
  instead of just "xpmData" if you really need to use it.

- wxWindow::DoGetBorderSize() was removed, if you used this non-public function
  in your code, you can replace it with public GetWindowBorderSize().

- Microsoft Visual Studio 2003 (a.k.a. MSVC 7) is not supported any longer, the
  minimum required version is now 2005.


3.2.9: (released 2025-12-12)
----------------------------

All:

- Backport several CMake enhancements from 3.3 (Maarten Bent, #25448, #25998).
- Fix using wxSOCKET_NOWAIT_READ and wxSOCKET_WAITALL_WRITE together (#17114).
- Make wxPlatformInfo::Get() thread-safe (#25459).
- Fix CMake build under Alpine Linux and other systems using musl (#25749).

All (GUI):

- Respect menu path style in wxFileHistory::AddFilesToMenu() (Bill Su, #25451).
- Don't assert in wxGridSizer::Calc{Cols,Rows}() if sizer is empty (#25641).
- Fix bitmap position in wxDC::DrawLabel() in high DPI (Blake Madden, #25888).
- Fix calling wxDataViewCtrl::Collapse() from event handler (#25631).
- Fix selecting columns in wxGrid with mouse (Dietmar Schwertberger, #25884).
- Improve wxActivityIndicator dots colour contrast with background (#25405).
- Update wxGenericTreeCtrl item height after changing its font (#16428).
- Respect HTML5 charset attribute in wxHTML (Kees van der Oord, #25546).

wxGTK:

- Add support for using EGL 1.4 (and not 1.5) in wxGLCanvas (#22325).
- Fix crash deleting wxTextCtrl from wxEVT_TEXT_ENTER handler (#26006).
- Fix handling total window size with GNOME with X11 (#25348).
- Fix height of read-only wxBitmapComboBox (#25468).
- Fix memory leak when using wxOverlay (#24500).
- Fix missing wxEVT_CHAR for Ctrl-Letter in non-US layouts (#25384).
- Fix regression when unmaximizing windows under XFCE/MATE (#25708).
- Fix wxGLCanvas scale when using EGL/Wayland in high DPI (Popax21, #23733).
- Show system default window buttons under Wayland (#25562).

wxMSW

- Fix regression in wxTreeCtrl indent size in high DPI (Maarten Bent, #25282).
- Fix using wxNO_IMPLICIT_WXSTRING_ENCODING with PCH (#25568).
- Fix crash when copying wxBitmaps if GDI resources are exhausted (#24703).
- Fix MSVS debug visualizer for wxString (#25684).
- Fix wxStyledTextCtrl support in screen readers (Maarten Bent, #25963).
- Fix TAB behaviour in a panel with notebook as only active child (#25443).
- Reduce GDI resource usage in wxStaticBitmap (Alex Shvartzkop, #25698).
- Significantly improve performance of drawing bitmaps in wxAUI (#23841).

wxOSX:

- Fix crash on startup when using Farsi as system language (#25561).
- Fix showing extra controls in wxFileDialog (jey5nd6, #25717).
- Do not activate "Close" button on Cmd-C (nobugshere, #25346).
- Fix memory leak in wxColour::Set() (#25569).
- Fix regression with configure build under macOS < 12 (#25675).
- Fix build under macOS 26 Tahoe (#25798).
- Fix build problem with memset_s() with PCH enabled (#24687).
- Fix invisible labels in wxGrid with native header control (#26014).
- Fix nested markup attributes handling (Václav Slavík, #25864).
- Fix possible use of already destroyed wxTimers (Federico Perini, #25871).
- Fix handling of multiple filters in wxFileDialog (#25918).
- Fix value in wxEVT_SPIN with non-0 initial value (Robert Roebling, #26002).
- Improve appearance of wxSpinCtrl (Robert Roebling, #26002).


3.2.8.1: (released 2025-05-25)
------------------------------

This hotfix release corrects regressions in 3.2.8 for configure builds on
platforms using ELF if --with-flavour is specified (#25436) or LTO is used
with clang (#25438).


3.2.8: (released 2025-04-24)
----------------------------

All:

- Allow initializing wxVector<> from std::initializer_list<> (#25290).
- Update Brazilian Portuguese translations (Felipe).
- Ensure that all headers are installed by CMake (Maarten Bent, #25266).
- Fix ABI breakage for versioned symbols in 3.2.7 under Unix (#25327).

All (GUI):

- Fix crash when using wxPropertyGrid on high DPI screen (#25286).
- Add "@USER@" macro to HTML and richtext printing (Blake-Madden, #25318).
- Fix "@PAGECNT@" when there is only one page (Blake-Madden, #25320).

wxGTK:

- Fix regression in numpad key event generation in 3.2.7 (#25263).
- Make key events for punctuation keys more consistent with wxMSW.
- Fix for computing wxStaticText best size with non-default font (#24781).
- Fix handling exceptions in wxApp idle event handler (#25312).

wxMSW:

- Fix menu padding regression in high DPI under Windows 11 (taler21, #25117).
- Allow using mouse wheel in wxSpinCtrlDouble (David Langhals, #24935).

wxOSX:

- Fix building third party libraries with Xcode 16.3 (David Connet).


3.2.7: (released 2025-03-20)
----------------------------

All:

- Avoid trailing space in `wx-config --c[xx]flags` (Tobiasz Laskowski, #24812).
- Fix building using gcc 14 under Solaris (Alan Coopersmith, #24869).
- Avoid warnings in event table macros with clang 19 (Lauri Nurmi, #25064).
- Add wxNO_UNUSED_VARIABLES to enable warnings about them (Lauri Nurmi, #24882).
- Install all translations in "make install" (Scott Talbert, #24880).
- Fix compilation with clang 19 (Lauri Nurmi, #24922).
- Fix crash in wxWebRequestCURL when connection was refused (#24885).
- Fix build with libc++ v19 (#24959).
- Add wxApp::SetErrorExitCode() to better handle initialization errors (#24770).
- Fix buffer read overflow when compiling RE ending with backslash (#25040).
- Fix crash in wxWebRequest::Close() with recent libcurl (#24969).
- Make wxTempFile::Commit() really atomic (#25088).
- Improve CMake install target and many other fixes (Maarten Bent, #24792).
- Use full toolkit version in wxGetLibraryVersionInfo() (Lauri Nurmi, #25175).

All (GUI):

- Improve wxPropGrid checkboxes in high DPI (Alex Shvartzkop, #24650, #24651).
- Don't break AUI layout if Update() called when window is iconized (#24930).
- Improve wxInfoBar appearance (#24838, #24902, #25048).
- Fix multiple bugs in wxStaticText::Wrap() (#23339).
- Show wxAuiToolBar long help text in frame status bar (Bill Su, #25157).
- Recognize "current" and "pressed" in wxBitmapButton XRC handler (#25114).
- Fix wrong row parameter in wxEVT_GRID_ROW_MOVE events (Tony Kennedy).
- Add subitem support to wxGenericListCtrl::HitTest() (Lauri Nurmi, #25153).
- Fix off by one error in wxImage::ResampleNearest() (Alex Shvartzkop, #25171).
- Fix WX_GL_COMPAT_PROFILE spelling (#24964).

wxGTK:

- Many fixes to key event generation (#25053, #25199, #25200).
- Fix copy-pasting text under more Wayland compositors (Weston, kwin) (#24701).
- Fix wxDropSource::DoDragDrop() sometimes not returning with Wayland (#25116).
- Fix insufficient wxStaticBox borders size (#25045).
- Fix unwanted "All pages" selection in the printing dialog (#24868).
- Fix size of wxDataViewCustomRenderer which was ignored in some cases (#24227).
- Respect the minimum size of controls in wxToolBar (#25210).
- Don't consume Ctrl-C when using SDL-based wxSound (Kyriet, #25067).
- Avoid repaint problems when using wxWindow::Update() with Wayland (#25036).
- Generate wxEVT_ENTER_WINDOW in icon part of wxSearchCtrl too (#24245).

wxMSW:

- Fix regression in wxDateTime support for years > 3000 in 3.2.5 (#25228).
- Improve print preview in high DPI (taler21, #24815).
- Fix position of the icons in the printout (#24673).
- Fix events generated when toast-based notifications are dismissed (#24320).
- Fix height of wxOwnerDrawnComboBox popup in high DPI (Maarten Bent, #24850).
- Fix background colour of owner-drawn wxListBox items (#24917).
- Fix handling pending events without an event loop (Stefan Battmer, #18109).
- Fix indent of imageless wxTreeCtrl in high DPI (taler21, #24941).
- Fix possible crash during session termination (#24903).
- Make wxKill(wxKILL_CHILDREN) work recursively (Wolfgang Dautermann, #25069).
- Use ReplaceFile() in wxRenameFile() to make operation atomic (#25088).
- Fix padding of wxMenu in high DPI (taler21, #24821).
- Recognize Windows Server 2025 in wxGetOsDescription() (PB, #25066).
- Fix spurious assert failures in wxFileSystemWatcher with Samba (#18953).
- Fix build errors in wx/vector.h if "new" is redefined (#24994).
- Fix -Wdeprecated-copy-dtor warnings in the headers with gcc 14 (#24248).

wxOSX:

- Fix build with macOS 15 SDK (#24724, #24879).
- Fix not making dialogs modal in some circumstances (Dmitry Makarenko, #25087).
- Fix missing mouse events in scrolled windows under macOS 14+ (#24790, #24809).
- Fix regression in GetPreferredUILanguage() in some cases (#24804).
- Fix Z-order of auto-complete popup of wxStyledTextCtrl (#25202).
- Fix CMake build with PCH disabled (Maarten Bent, #24851).
- Fix truncating labels of newly added wxNotebook pages (#25194).
- Fix truncating wxEvent time stamp after ~25 days (Artur Sochirca, #24960).
- Implement clipboard events for single-line wxTextCtrl too (#25165).
- Implement wxCursor::GetHotSpot() (Daniel Collins, #24961).
- Handle wxSYS_CURSOR_[XY] in wxSystemSettings (Daniel Collins, #24962).


3.2.6: (released 2024-09-09)
----------------------------

All:

- Backport multiple fixes to CMake build system from 3.3 (Maarten Bent, #24616).
- Fix regression in wxTranslations language resolution introduced in 3.2.3 (#24297).
- Add wxTranslations::AddAvailableCatalog() overload with msgid language (#24297).

All (GUI):

- Fix resource leak in wxBitmapBundle in some circumstances (#24703).
- Speed up using XRC when using wxXRC_NO_RELOADING (John de Rooij, #24536).
- Fix wxGridBagSizer with different horz/vert gaps (Alex Shvartzkop, #24550).
- Dark mode appearance fixes for wxActivityIndicator, wxHyperlinkCtrl, etc.
- Fix using wxNOT_FOUND index with wxDataViewChoiceByIndexRenderer (Konstantin
  S. Matveyev, #24741).
- Improve wxWizard appearance in high DPI (taler21, #24743).
- Fix wxPropertyGrid row height in high DPI (taler21, #24607).

wxGTK:

- Fix possible crash during drag-and-drop (#24677).
- Fix using wxDatePickerCtrl in ca_ES, cs_CZ and some other locales (#24533).
- Fix wxListBox minimum size regression in 3.2.5 (#24551).
- Fix wxBitmapComboBox bitmaps scaling in high DPI (#24563).
- Allow positioning wxDialog at specified position, at least under X11 (#24552).
- Fix incorrect handling of ligatures in wxStyledTextCtrl (Funami580, #13168).
- Fix using wrong keyboard layout in key events (Ivan Sorokin, #24772).
- Fix wrong wxStaticText layout on non-first wxWizard page (#19053).

wxMSW:

- More Windows Server versions in wxGetOsDescription() (PB, #24598, #24603).
- Fix using wx/wxprec.h with vcpkg (Maarten Bent, #24353, #24632).
- Fix wxNotebook size calculation in high DPI (#24606).
- Fix size of dragged text in wxDataViewCtrl in high DPI (taler21, #24648).
- Fix crash when using static wx libraries in a DLL (#24730).
- Fix some warnings from Windows SDK headers with MSVC /W4 (#23716).

wxOSX:

- Fix regression with not accepting focus under macOS 14+ (#24605, #24667).
- Improve wxSlider ticks appearance (Hartwig Wiesmann, #24532).
- Fix wrong wxSlider label in some cases (Hartwig Wiesmann, #24539).
- Fix handling diagonal scrolling when using trackpad (#24516).
- Improve wxScrollBar precision (Alex Contreras, #24669).
- Improve context menus in wxDataViewCtrl (Václav Slavík, #24697).


3.2.5: (released 2024-05-14)
----------------------------

All:

- Add support for "%F" format specifier to wxDateTime (#24173).
- Support dates > 2038 if time_t is 64-bit (Lauri Nurmi, #24464).
- Restore possible ABI incompatibility with wx < 3.2.3 in wxString.
- Set request and response for wxEVT_WEBREQUEST_DATA events (#24416).

All (GUI):

- Fix division-by-zero in wxRichTextCtrl (#23763).
- Make wxGraphicsContext offsetting consistent across scales (#23485).
- Improve error checking when saving TIFF images (Brian Delalex, #23214).
- Fix crash in wxLogGui when wxUSE_LOG_DIALOG==0 (Randalphwa, #24087).
- Use wxUILocale in wxFloatProperty (Miguel Gimenez, Artur Wieczorek, #24140).
- Fix crash in wxImage::InitAlpha() if image is invalid (Randalphwa, #24260).
- Fix wxLogStatus() when wxNO_IMPLICIT_WXSTRING_ENCODING is defined (#24267).
- Don't let exceptions escape from event handlers called during idle processing.
- Fix reading some previously not loaded GIF images (Mark Wagner, #22799).
- Fix wxGrid selection after deleting rows/cols (Dietmar Schwertberger, 24286).
- Auto-grow in-place editor in generic wxListCtrl again (taler21, #24293).
- Center labels in generic wxListCtrl correctly again (taler21, #24292).
- Fix label display after editing it in generic wxListCtrl (taler21, #24311).
- Improve multiple selection UI in generic wxListCtrl (taler21, #24332).
- Fix item deselection in multi-selection generic wxListCtrl (taler21, #24312).
- Reduce flicker when closing wxAuiNotebook tab (Eran Ifrah, #24372).
- Don't include Ctrl+I/Ctrl+H in "TAB"/"cut" key categories (#24254).
- Make text in wxGenericMessageDialog more readable (Jeff Young, #24412).
- Fix handling non-square bitmaps in wxBitmapBundle (#24433, #24434).
- Add wxTE_PROCESS_ENTER to wxSpinCtrl[Double] XRC handlers (JohnKnow, #24481).
- Update popup menu UI before showing it (Bill Su, #24641).

wxGTK:

- Fix copying/pasting text under Wayland (#24391).
- Fix alpha in bitmaps created from SVG (Tim Eliseo, #24064).
- Improve desktop environment detection, notably under Wayland (#24050).
- Fix wxSystemSettings::GetMetric() scrollbar width calculation for GTK3 (#24057).
- Minimal wxVideoMode support for Wayland (#24021).
- Fix wxCheckBox::SetValue() when in undetermined state (#24074).
- Fix for incorrect preferred size from empty wxChoice with GTK3 (#23382).
- wxDropSource::GiveFeedback() fixes (#24051).
- Fix wxCheckBox undetermined state showing as checked with some themes (#24074).
- Fix crash with GTK3 if console program is using a GUI wxApp class (#24081).
- Generic wxDataViewCtrl drag hint fixes (#24084).
- Ensure wxListBox best size is at least the minimum required by GTK3.
- Support setting thickness when creating wxGauge with GTK >= 3.20 (#24107).
- Fix handling binary data in wxSecretStore (Martin Corino, #24351).
- Make GTKSuppressDiagnostics(), broken since 3.2.1, work again (#24432).
- Fix wxTE_PROCESS_ENTER in wxGTK comboboxes with autocomplete (#24394).
- Fix -Wdeprecated-copy-dtor warnings in the headers with gcc 14 (#24502).
- Position popup menu shown from keyboard correctly (#24522).

wxMSW:

- Add support for line spacing and bullet style attributes to wxTextCtrl
  (Blake-Madden, #24046, #24069).
- Fix possible crash in wxFileSystemWatcher (Rick van der Sluijs, #24119).
- Fix restoring hidden top level windows (Christian Walther, #24117).
- Add support for VT_UI8 OLE VARIANT type (Miguel Gimenez, #24115).
- Fix using "Alt" when wxGrid has focus (Dietmar Schwertberger, #24247).
- Fix wxButton::GetDefaultSize() in high DPI under MSW (#24283).
- Improve native MSW dialog DPI awareness (Maarten Bent, #24196).
- Fix bug with not showing some wxStaticText labels (#24365).
- Fix button size of generic wxColourPickerCtrl in high DPI (taler21, #24456).

wxOSX:

- Updates for macOS 14 Sonoma support (#23916, #24054, #24067, #24073, #24515).
- Restore activation for non-bundled applications (#24056, #24062).
- Fix wrong tooltips for cells with custom renderers in wxDataViewCtrl (#24370).
- Fix handling of nested modal dialogs (WakA, #24418).
- Fix translations when using zh-Hans-CN locale (#24396).
- Add filters support to wxFileDialog::ShowWindowModal() (Gammasoft, #24438).
- Fix installation on some Apple Silicon Macs (Thomas Holder, #23143, #24524).
- Recognize macOS 15 Sequoia in wxGetOsDescription() (Tobias Taschner, #24647).

wxQt:

- Fix wxAnyButton Current/Normal state confusing (David Karoly, #24129).


3.2.4: (released 2023-11-11)
----------------------------

All:

- Allow creating wxArrays from std::initializer_list (Lotendan, #23966).
- Fix regression in wxTranslations::AddCatalog() return value (#24019).

All (GUI):

- Fix possible crash when dragging pages in wxAuiNotebook (#24027).
- Fix refreshing multiple selection items in generic wxListCtrl.

wxGTK:

- Fix some regressions introduced in 3.2.3:
  * Don't crash in console apps linked with GUI libraries (#23981).
  * Fix possible crash and too high CPU use when using EGL (#24018).
  * Fix losing clipboard contents when clearing a different selection (#23988).

wxMSW:

- Fix MSVS warning about redundant "const" in wx/itemid.h (#23590).

wxOSX:

- Fix showing windows for background apps under macOS Sonoma (#23893).


3.2.3: (released 2023-10-10)
----------------------------

All:

- Fix wxTranslations::AddStdCatalog() and add AddAvailableCatalog() (#18227).
- Add move ctor and assignment operator to wxString (Pavel Tyunin, #23224).
- Enable large file support in Unix CMake builds (Maarten Bent, #22750).
- Make wxSocket::Peek() work with UDP too (Brian Nixon, #23594, #23604).
- Update Georgian translations (NorwayFun, #22673).
- Don't use invalid iterator in wxString in UTF-8 build (Ian Day, #23305).
- Fix wrong description for some languages (Ulrich Telle, #23419).
- Fix infinite loop in wxFTP::GetFilesList() (#23519).
- Use grep instead of fgrep and egrep in makefiles/scripts (#23537).
- Use /etc/os-release if lsb_release isn't available (Scott Talbert, #23712).
- Add wxUILocale::GetMonthName() and GetWeekDayName() (Ulrich Telle, #23556).
- Support WAV files with LIST chunks under Unix (A. Jiang, #23859).
- Fix CMake build if wxWidgets directory contained "++" (Maarten Bent, #22738).

All (GUI):

- Don't allow pasting characters forbidden by wxTextValidator (#10281).
- Fix wxFLEX_GROWMODE_ALL in wxFlexGridSizer with proportions (#23253).
- Make wxListCtrl checkboxes behaviour more consistent (Maarten Bent, #23869).
- Fix wxEditorDialogProperty in wxPropertyGrid (#23272).
- Fix entering dates in wxGenericDatePicker in nb_NO and other locales
  using names for the months in short date format (#23310).
- Fix wx-config output when using NanoSVG library (#23373).
- Fix bug modifying shared images in wxImage::Clear() (#23555).
- Add EVT_FULLSCREEN event macro (Christian Beier, #23566).
- Clear old attributes when changing wxGrid table (Brian Nixon, #23607).
- Fix background colour of wxVListBox (Maarten Bent, #23641).
- Fix return value of wxAuiToolBarItem::GetDisabledBitmap() (taler21, #23666).
- Fix buffer overflow in wxHTMLDataObject::GetDataHere() (mcorino, #23660).
- Fix crash when loading some mal-formed GIFs (PB, #23409).
- Relax checks on character entry in numeric validators (#12968, #23561).
- Fix wxRibbonToolBar::GetToolByPos() and DeleteToolByPos() (mcorino, #23457).
- Update wxOwnerDrawnComboBox best size when adding items (Reza Karimi, #23681).
- Keep wxProgressDialog size when updating the message (Oleg Samarin, #23727).
- Fix crash when deleting selected item in wxGenericListCtrl (#23729).
- Use DIPs for toolbar image sizes in wxPropertyGrid.
- Fix undefined behaviour in wxImage::Paste() (aurel32, #23791).
- Fix EVT_PRESS_AND_TAP() event macro definition (Kumazuma, #23819).
- Fix wxFileHistory formatting after calling Load() (Hartwig Wiesmann, #23799).
- Fix wxRichTextCtrl layout in high DPI (mbc-one, Maarten Bent, #23828).
- Ensure current cell stays valid when wxGrid table changes (CookieLau, #23751).
- Always give focus to the currently shown wxSimplebook page (#23914).

wxGTK:

- Fix key codes with Shift on non-US keyboards (Ivan Sorokin, #17643, #23379).
- Fix possible crash when using IME under Wayland (#23760).
- Avoid catastrophic slowdown when hiding wxGLCanvas under Wayland (#23512).
- Give better error if EGL version is < 1.5 (Fabrice de Gans, #22325, #23855).
- Fix hiding wxGLCanvas under Wayland (Joan Bruguera, #22580).
- Fix page origin when printing in landscape (Alex Shvartzkop, #23860).
- Fix wxComboCtrl popup behaviour under Wayland (Alex Shvartzkop, #23908).
- Dramatically optimize adding many items to wxChoice (Ian McInerney, #23443).
- Improve and document wxGLCanvas::CreateSurface() (Dan Gudmundsson, #23366).
- Fix loading WebKit2 extension when using wxWebView (Scott Talbert, #23497).
- Fix editing cells without values in wxDataViewCtrl (#23523).
- Fix showing popup menu with GTK/Wayland without active event (#23892).
- Fix uninitialized wxKeyEvent::m_isRepeat (jolz, #23593).
- Improve best size computation of wxTextCtrl (Alex Shvartzkop, #23610).
- Fix missing borders for scrollable windows, e.g. wxListCtrl (#23236).
- Fix TAB navigation in wxPropertyGrid (Adrian Lopez, #23354).
- Fix GSource leak when using wxIdleEvent::RequestMore() (#23364).
- Allow using libwebkit2gtk-4.1 and libsoup-3.0 (Scott Talbert, #23630).
- Support Numpad Enter for ending wxListCtrl editing (Scott Talbert, #23762).
- Improve dark mode detection (Colin Kinloch and Paul Cornett, #23764).
- Fix wxPreferencesEditor size under Wayland (#23924).
- Fix not showing text in wxBusyInfo (#23936).
- Make wxRB_SINGLE really work (Stefan Hansson, #23652).
- Fix (not) refreshing virtual wxListCtrl after deleting its last item.

wxMSW:

- Fix (deprecated) build without Unicode support broken in 3.2.2 (#23516).
- Fix crash when using wxBitmapDataObject in wxDataObjectComposite (#23564).
- Fix setting locale for wxLANGUAGE_UKRAINIAN (Ulrich Telle, #23210).
- Fix matching wildcards ending with "*.*" in wxDir (#23905).
- Don't reset custom wxToolBar background on system colour change (#23386).
- Fix wxUILocale::GetPreferredUILanguages() with OS < 10 (Brian Nixon, #23416).
- Fix building with LLVM clang (Sergey Khalyutn, Maarten Bent, #23464).
- Fix discrepancy between GDI and Direct2D in high DPI (Kumazuma, #23486).
- Fix wxTreeCtrl::ScrollTo() with hidden root item (#23534).
- Fix hang in wxFileDialog if COINIT_MULTITHREADED was used (#23578).
- Fix handling of RLE-compressed bitmaps (Brian Nixon, #23573).
- Fix wxWindow::GetTextExtent() with given font in high DPI (#23542).
- Fix drawing owner-drawn menu items with bitmaps (Jacob Gillespie, #23230).
- Improve ScrollTo() with wxDV_VARIABLE_LINE_HEIGHT (Jens Göpfert, #23102).
- Fix libraries names in Arch64 CMake build (Tobias Taschner, #23347).
- Fix using wxComboCtrl with AUI floating pane as parent (#23399).
- Fix wrong wxWindowsPrintNativeData initialization (Stefan Ziegler, #23685).
- Fix position of wxStaticBox label after DPI change (Maarten Bent, #23740).
- Fix background colour of empty cells in wxDataViewCtrl (#23708).
- Fix possible (even if rare) crash in printer progress dialog (#23927).
- Fix "+" button not appearing in wxTreeCtrl after adding a child (#23718).
- Fix phantom mouse events after dismissing wxFileDialog (charvey2718, #10924).

wxOSX:

- Fix missing key events for ⌘+⎇+Letter combinations (#23671).
- Add support for wxDP_DROPDOWN under macOS 10.15.4+ (Lauri Nurmi, #23520).
- Fix initial width of empty wxTextCtrl (#23295).
- Fix underlined fonts sometimes appearing without underline (#23264).
- Respect composition mode when drawing bitmaps (#23240).
- Fix background colour of shaped windows, e.g. wxRichToolTip (#23296).
- Fix memory leak in wxFileDialog using custom controls (#23304).
- Restore setting C-level locale when using wxLocale (#23557).
- Check column for wxEVT_DATAVIEW_ITEM_ACTIVATED (Hartwig Wiesmann, #23636).
- Fix spurious -Wundeclared-selector with Xcode 14 (Hartwig Wiesmann, #23639).
- Recognize macOS 14 Sonoma in wxGetOsDescription() (Tobias Taschner, #23615).
- Fix setting Chinese locales (#23209).
- Wrap wxStaticText contents (#23341).
- Fix invisible wxStaticLine under macOS >= 13 (#23913).

wxUniv:

- Fix resetting the hint in wxTextCtrl when it gets focus (Kvaz1r, #23511).
- Fix creating wxRadioBox without any items (Kvaz1r, #23784).


3.2.2.1: (released 2023-02-13)
------------------------------

This hotfix corrects a regression in 3.2.2 which resulted in not drawing any
icons for the non-root item of wxGenericTreeCtrl in this release (see #23255).


3.2.2: (released 2023-02-08)
----------------------------

All:

- Fix regression in saving TIFF images that could end up truncated (#23048).
- Fix long standing bug in parsing wxHTTP responses.
- Fix wx-config generation in CMake builds (Maarten Bent, #22806).
- Fix compilation of code using wxTransformMatrix with recent gcc (#22790).
- Fix memory leak when destroying wxThread (Antti Nietosvaara, #22840).
- Add serial number to wxwin.m4 file (#22848).
- Update Expat submodule to include the fix for CVE-2022-40674.
- Update zlib to 1.2.13.1 to include the fix for CVE-2022-37434 (#22919).
- Allow 'T' separator in wxDateTime::ParseDateTime() (Blake-Madden, #22999).
- Add Serbian translations (Nikola Jović).
- Fix MT-safety problem in wxZipInputStream (#23054).
- Fix building all samples in release build with CMake (#23106).
- Fix using pkg-config when cross-compiling (#22886, #23037, #23171).
- Fix compilation problem in wxUILocale code when using musl (Khem Raj, #23050).
- Add wxUILocale::GetSystemLocaleId() replacing GetSystemLocale() (#23114).
- Fail when setting unsupported "mixed" locale under Unix (#23218).

All (GUI):

- Improve wxWebView::RunScriptAsync() performance (Tobias Taschner, #22781).
- Fix data race when processing events generated in a worker thread.
- Fix compilation problem in wx/propgrid/editors.h (Loïc Bartoletti, #22875).
- Fix wxGeneric{List,Tree}Ctrl high DPI icons (Gerhard Stein, #22887, #22916).
- Add macros for event tables for missing wxWebView events (PB, #22949).
- Improve month selection in wxGenericCalendarCtrl (Lauri Nurmi, #22853).
- Fix maximum length of wxPropertyGrid editors (#23033).
- Add support for Caps/Num/Scroll Lock to wxGetKeyState() (elfmz, #23195).
- Fix wxToolBar::GetToolBitmapSize() in high DPI under non-MSW (#23222).

wxGTK:

- Fix resizing wxGLCanvas with EGL and Wayland (Carl Hetherington, #22811).
- Fix missing X11 libraries when linking with wxGTK2 statically (#22813).
- Fix compilation with GTK 3.22.z and z < 25 (#22816).
- Fix compilation with GTK < 2.21.8 (mkirkham, #22830).
- Fix display artefacts when using AUI without compositor under X11 (#23135).
- Allow selecting and copying text in wxMessageDialog (Ian McInerney, #23039).
- Fix initial size of top-level window on Wayland (#23041).
- Improve size and behaviour of in-place editor in wxTreeCtrl (taler21, #23001).

wxMSW:

- Fix crashes when using wxTextCtrl with MinGW TDM 64 (#22639).
- Avoid appending extraneous NUL bytes to wxTextDataObject text (#22928).
- Improve resizing of some windows on DPI change (#23091).
- Fix wrong size of native MSW icons in wxArtProvider in high DPI (#23127).
- Fix glitch in drawing wxStaticBox with a control as label (#22952).
- Save windows geometry correctly when using Aero Snap (Randalphwa, #22730).
- Fix generating wxEVT_TEXT_ENTER in wxBitmapComboBox (#16318).
- Fix return value of wxZoomGestureEvent::GetZoomFactor() (s-murphree, #22818).
- Update top level icon resolution on DPI change (#22807).
- Fix scaling of standard MSW icons in high DPI (#23031).
- Fix menu items with custom font in high DPI (#22957).
- Remove "Printing" from title when printing to PDF (Blake-Madden, #22836).
- Fix sometimes missing overwrite prompt in "Save" file dialog (#22898).
- Set wxUSE_TASKBARBUTTON correctly when building using configure (#22900).
- Queue wxWebViewEdge events to avoid hangs (Tobias Taschner, #23025).
- Fix getting printer information in the print dialog (Stefan Ziegler, #23068).
- Fix building samples with clang under MSYS (Maarten Bent, #23057).
- Fix memory leak when allocating command line arguments (#23081).
- Include wxrc.exe in 64-bit wxMSW MSVC dev archive too (Danny Scott, #23122).
- Don't disable wxComboBox after recreating it (Oleksandra Yushchenko, #23132).
- Fix wxJoystick::GetProductName() returning nothing (Maarten Bent, #23172).
- Work around MSVS 2022 optimizer bug in wxImage::ShrinkBy() (#23164).
- Fix link error with wxSimplebook in DLL builds (Mark Roszko, #22805).
- Avoid errors when including wx/msw/msvcrt.h before other wx headers (#23194).

wxOSX:

- Fix possible crash in menu item event handling (#23040).
- Fix regression in text drawing when using clipping (#22629).
- Don't round fractional point size when creating fonts (#23144).
- Do round size returned by wxFont::GetPixelSize().
- Map wxFONTFAMILY_DEFAULT to wxFONTFAMILY_SWISS as in the other ports (#23158).
- Generate wxEVT_DATAVIEW_COLUMN_HEADER_RIGHT_CLICK (#22833).
- Fix wxDataViewCtrl::HitTest() (Vojtěch Bubník, #22789).
- Fix position of the controls in wxStaticBox after resizing it (#22837).
- Ensure that "Window" menu is inserted before "Help" (#22871).
- Fix compiling with Xcode 7.3 and macOS 11 SDK (crazbot, #22988).
- Always call wxTaskBarIcon::GetPopupMenu() (William Lindnilsson, #23008).
- Fix scaling wxTaskBarIcon in high DPI (William Lindnilsson, #23042).
- Add margins around wxListCtrl items to improve appearance (#23155).
- Fix shortcuts handling in wxWebView (#23151).
- Make wxLOCALE_FORM_ENGLISH actually work (Ulrich Telle, Lauri Nurmi, #23190).
- Fix "Window" menu item not being translated sometimes (#23204).
- Fix wxLocale::GetCurrent() when the current locale is "C".
- Fix wxLocale::Init(wxLANGUAGE_DEFAULT) with "mixed" locales (#23114).

wxQt:

- Fix creating wxFont using fractional point size (Ali Kettab, #23163).


3.2.1: (released 2022-09-09)
----------------------------

All (GUI):

- Add wxFileDialog::AddShortcut() (#22543).
- Fix grid window scrollbars when freezing part of the grid (#22602).
- Avoid warnings with wxStaticText flags in C++20 (David Connet, #22656).
- Fix AUI floating pane position when dragging (Konstantin S. Matveyev, #22533).
- Add wxStyledTextCtrl support to XRC schema file.
- Fix script parsing in wxLocaleIdent (Ulrich Telle).
- Make generic wxListCtrl separator lines more visible in dark themes (#22664).

wxGTK:

- Fix crash with wxNotebook and g_log_set_writer_func() in glib 2.73+ (#22717).
- Fix editors not appearing in wxGrid in some rare circumstances (#22628).
- Ignore attempts to draw circles with zero radius again (#22775).
- Fix build with --disable-intl (#22626).
- Fix build under MSW (Tim Stahlhut, #22633).
- Fix CMake build under NetBSD (Thomas Klausner, #22643, #22644, #22645).
- Improve linking with OpenGL libraries in CMake build (Maarten Bent, #22649).
- Fix new warnings from gcc 12.1.
- Correctly GTK print support and libnotify in CMake builds.

  NOTE: CMake builds of 3.2.1 may be not ABI-compatible with 3.2.0 if
        libnotify is available, specify -DwxUSE_LIBNOTIFY=0 to preserve
        ABI compatibility if needed (at the price of not using libnotify).

wxMSW:

- Fix regression with background of menu bitmaps without alpha (#22669).
- Fix regression in bitmaps with alpha in image list without mask (#22754).
- Fix build with MSVC when using standard preprocessor (k3DW, #22654).
- Work around MSVS 2022 optimizer bug in wxImage::ResampleBox() (#22761).

wxOSX:

- Fix missing key and kill focus events for wxSearchCtrl (#19321, #22702).
- Fix wxrc installation with "make install" (Mark Harfouche, #22620).
- Fix positioning windows on non-main screen (#22614).
- Fix wxBitmapBundle compatibility when using template NSImages (#22623).
- Fix bezel style of borderless wxToggleButton (#22140).
- Improve wxWebView full screen support (Tobias Taschner, #22637).
- Fix crash when creating wxRadioBox without any items (#22751).


3.2.0: (released 2022-07-07)
----------------------------

All:

- Build fixes for Unix systems using older Cairo or glibc versions.
- Fix wxFileName::ReplaceHomeDir() when HOME=="/".
- Fix wxLocale::IsAvailable(wxLANGUAGE_DEFAULT) regression.
- Provide CMake config file for the library.
- Add a 'revision' component to wxVersionInfo (Ronny Krüger).

All (GUI):

- Make loading bitmaps using BI_BITFIELDS work again.
- Fix wxGenericListCtrl::GetColumnCount() for wxLC_LIST (Kvaz1r).
- Fix refresh after calling wxGenericListCtrl::EnsureVisible() (taler21).
- Add wxMenuItem::GetBitmapBundle().
- Support additional wxWizard properties in XRC (Randalphwa).

wxGTK:

- Fix wxDC::Blit() and wxBitmap::GetSubBitmap() with HiDPI bitmaps.
- Fix TAB navigation in wxSimplebook (Adrian Lopez).
- Support wxINVERT logical operation on wxDC with white source colour.
- Don't assert in wxGtkImage (used in e.g. wxToolBar) when bitmap is missing.
- Fix wxListBox selection colors with non-default background (alilie).
- Fix wxCURSOR_SIZING with Wayland.
- Recognize modern versions of GNOME in GetDesktopEnvironment() (Ulrich Telle).

wxMSW:

- Fix wxDC::DrawRoundedRectangle() and wxImageList::Draw() regressions.
- Fix wrong results of wxWebResponse::GetHeader() and GetURL().
- Fix creating wxBitmap of depth 32 but without real alpha.
- Improve top level window resizing on DPI change and allow overriding it.

wxOSX:

- Fix regression in wxTextCtrl best size calculation.
- Fix activation of applications using LSUIElement == true.
- Fix AUI sash appearance in dark mode (alilie).
- Recognize macOS 12 in wxGetOsDescription() (Tobias Taschner).


3.1.7: (released 2022-06-06)
----------------------------

INCOMPATIBLE CHANGES SINCE 3.1.6:

- wxImageFileProperty::m_pImage and m_pBitmap member variables were removed.
  They were not intended for the public API. m_image variable represents
  cached image now.

- wxPropertyGridPageState functions intended for internal use are no longer
  public. Corresponding functions in wxPropertyGridInterface, wxPropertyGrid,
  wxPropertyGridPage, and wxPropertyGridManager should be used instead.


All:

- Improvements to CMake, notably better PCH support.
- Add wxTRANSLATE_IN_CONTEXT() (Lauri Nurmi).
- Fix wxIPV6address initialization.

All (GUI):

- Further improve bitmap rescaling logic in high DPI.
- Add wxEVT_GRID_ROW_AUTO_SIZE to wxGrid (Dietmar Schwertberger).
- Add possibility to drag-move wxGrid rows too (Dietmar Schwertberger).
- Improve UI of several mouse operations in wxGrid (Dietmar Schwertberger).
- Add support for 3rd wxCheckBox state to XRC (Randalphwa).
- Add support for more wxBitmap attributes to XRC (Randalphwa).
- Add support for wxSpinCtrl digits attributes to XRC (Randalphwa).
- Add wxBitmapBundle::FromIconBundle() (Uwe Runtemund).
- Allow getting current ribbon tool rectangle (Uwe Runtemund).
- Allow sharing client data in wxGrid-related classes (Frode Roxrud Gill).
- Fix font sizes in wxSVGFileDC (Maarten Bent).
- Fix layout of wxWrapSizer in wxFlexGridSizer (Antti Nietosvaara).
- Fix wxRichToolTipPopup appearance in high DPI (Maarten Bent).

wxGTK:

- Avoid GDK errors when using PopupMenu() with Wayland.
- Fix drag and drop in generic wxDataViewCtrl (Konstantin Matveyev).

wxMSW:

- Provide new IFileDialog-based customization API.
- Fix handling of standard accelerators in wxSpinCtrl (Dietmar Schwertberger).
- Fix infinite recursion in wxAuiNotebook::OnHelp().
- Fix performance regression in wxSTC redrawing (Maarten Bent).
- Fix regression in wxFileName::Normalize(wxPATH_NORM_LONG) and UNC paths.
- Fix sizes in the standard font dialog in high DPI.
- Fix warnings about bitwise operations with MSVC in C++20 mode.

wxOSX:

- Fix disappearing dialogs when using Spaces.
- Suppress menu items automatically added by macOS 12.
- Allow user input in wxPopupTransientWindow.
- Don't touch existing libraries in make install (Lauri Nurmi).
- Generate events for 4th and 5th mouse buttons (Lauri Nurmi).

wxUniv:

- Fix client data memory leak in wxListBox (Kvaz1r).


3.1.6: (released 2022-04-04)
----------------------------

All:

- Add wxUILocale: CompareStrings(), GetLocalizedName() etc.
- Add convenient wxFileName::GetAbsolutePath() helper.
- Add support for std::string_view to wxPrintf() etc.
- Add wxString::ToInt() and ToUInt() (Gerhard Gruber).
- Add wxGetNativeCpuArchitectureName() (Tobias Taschner)
- Add wxSecureZeroMemory() (Lauri Nurmi).
- Add wxThread::SetName() (Lauri Nurmi).
- Recognize Windows 11 and macOS 12 in wxGetOsDescription() (Tobias Taschner).
- Significantly speed up wxMBConv iconv-based implementation (rlbxku1r).
- Support searching from end in wxArrayString in STL build (Pavel Tyunin).
- Update and extend list of known locales (Ulrich Telle).
- Several improvements to parsing dates in wxDateTime (Lauri Nurmi).
- Fix new compilation warnings with clang 13.
- Fix warnings when building with gcc 11 and clang 12 -std=c++20.
- Replace deprecated AC_HELP_STRING in wxwin.m4 (Alexander Bisono).

All (GUI):

- Add wxBitmapBundle and use it throughout the entire API and in XRC.
- Add support for using native spell checking in wxTextCtrl (iwbnwif).
- Add support for style to wxWizard XRC handler (ousnius).
- Add WXSUPPRESS_SIZER_FLAGS_CHECK and improve assert messages.
- Add sort indicators support to wxListCtrl (Maarten Bent).
- Add support for extra menu item accelerators (Alexander Koshelev)
- Add wxDPIChangedEvent::Scale().
- Add wxEVT_SPLITTER_SASH_POS_RESIZE (Gerhard Gruber).
- Add wxImage::Change{Saturation,Brightness,HSV,Lightness}() (Tomay).
- Add wxIntegerValidator ctor taking range (Simon Stone).
- Add wxKeyEvent::IsAutoRepeat() (MArk Jessome).
- Add wxMC_NO_AUTORESIZE wxMediaCtrl style (Scott Talbert).
- Add wxSpinCtrl::GetTextValue().
- Add wxSpinCtrl::SetIncrement() (Igor Korot).
- Add wxStyledTextCtrl XRC handler (Alexander Koshelev)
- Add wxTopLevelWindow::SetContentProtection() (Tobias Taschner).
- Add wxWebView::RunScriptAsync() (Tobias Taschner).
- Add wxXmlResource::LoadDocument().
- Allow dropping multiple formats on wxDVC (Konstantin S. Matveyev)
- Allow using any window for the visible part of wxComboCtrl.
- Fix <big> and <small> tags handling in wxHTML (bakcsizs).
- Fix DPI change handling in wxGrid with hidden row/column labels.
- Fix handling of floating and resizable AUI toolbar panes (Kvaz1r).
- Fix loading BMP files using RLE (David Costanzo).
- Fix loading BMP files with malformed biClrUsed field (David Costanzo).
- Implement drawing splines in wxSVGFileDC
- Improve wxSpinCtrlDouble significant digits handling.
- Optimize wrapping long lines in wxRichTextCtrl (Mehmet Soyturk).

wxGTK:

- Many bug fixes for Wayland-specific problem.
- Fix missing mouse events after enabling touch events (Thierry Bultel).
- Allow suppressing GTK diagnostics (Marco DeFreitas).
- Fix getting key events from wxDataViewCtrl.
- Fix getting wxPrintData from the print dialog.
- Fix wxMediaCtrl support when using Wayland (Dominique Martinet).
- Generate wxKeyEvents for GDK_KEY_LaunchX keys (Dominique Martinet).

wxMSW:

- Add MSVS 2022 support.
- Use Winsock 2 by default.
- Make all native modal dialogs app modal.
- Fix setting focus to wxWebViewEdge (PB).
- Fix handling of ampersands in wxCheckListBox items.
- Fix crash in wxWebViewIE::Find() (PB).
- Fix size of the buttons when not using a manifest.
- Fix spurious assertions when using unknown Win32 locales.
- Fix wxDC::Blit() when using RTL layout (Dimitri Schoolwerth).
- Fix wxDataViewModel::ItemAdded() for closed nodes (Ilya Sinitsin).
- Fix wxStaticBox repainting in RTL (AliKet).
- Implement getting/releasing HDC in Cairo wxGraphicsContext
- Implement getting/releasing HDC in Direct2D wxGraphicsContext
- Improve dark mode detection (QuentinC)
- Use correct default printer settings (Stefan Ziegler).

wxOSX:

- Implement undo/redo for (multiline) wxTextCtrl (Dan Korn).
- Implement wxCmpNatural() using the same order as Finder does.
- Implement wxEVT_CHAR generation for wxDataViewCtrl.
- Implement wxFSVolume for macOS (Tobias Taschner).
- Allow having multiple lines in single line wxTextCtrl (Tobias Fleischer).
- Allow setting full screen view options (Tobias Taschner).
- Fix crash when clearing wxDataViewModel (Konstantin S. Matveyev).
- Fix handling of drag-and-drop in native controls.
- Fix right click event generation for wxComboBox (Daniel Kulp).
- Fix symlinks support in wxFileSystemWatcher (Richard Gibson).
- Fix task bar icon size in high DPI (Dominic Letz).
- Significantly speed up creating standard system fonts.

wxUniv:

- Many fixes to event generations, scrolling etc (Kvaz1r).
- Fix refresh problems when scrolling with mouse wheel (Kvaz1r).
- Many improvements and bug fixes in wxTextCtrl (Kvaz1r).
- Fix handling mouse capture in menus (Kvaz1r).


3.1.5: (released 2021-04-14)
----------------------------

All:

- Add wxWebRequest with support for HTTPS and HTTP/2 (Tobias Taschner).
- Add wxGetCpuArchitectureName() (Lauri Nurmi).
- Add support for 64-bit integers to wxConfig.
- Add wxFileName::ResolveLink() (Ian McInerney).
- Add wxString::utf8_string().
- Use millisecond resolution for wxLog timestamps.
- Fix wrong FIFO/sockets detection in wxFileName (atbara46).
- Fix search in wxSortedArrayString with custom comparator (Pavel Tyunin).
- Allow translations for different versions to co-exist (Andriy Byelikov).
- Eliminate really all gcc warnings from wx headers.
- Avoid gcc -Wsuggest-override inside wx macros (Teodor Petrov).
- Bug fixes and improvements in wxConvAuto (Pavel Tyunin).

All (GUI):

- Add wxPersistentComboBox to save user input history easily.
- Add alpha blending support to wxImage::Paste() (Rachel Mark, Eric Raijmakers).
- Add wxImageDataObject for copying wxImage to/from clipboard (Artur Wieczorek).
- Add support for user script messages to wxWebView (Tobias Taschner).
- Add wxFileHistory::SetMenuPathStyle() (Ian McInerney).
- Add wxEVT_GRID_RANGE_SELECT{ING,ED} (Daniel Kulp).
- Add wxGrid::wxGridSelectNone selection mode (Gary Allen).
- Fix changing in wxGrid with multicells (Dimitri Schoolwerth).
- Fix custom date formats in wxGrid.
- Improve wxGrid appearance in dark mode (Daniel Kulp).
- Optimize handling of attributes in wxGrid (Dimitri Schoolwerth).
- Fix infinite loop with auto-wrapped cells in wxGrid (Dimitri Schoolwerth).
- Apply data transfer to the window itself too (Ali Kettab).
- Add wxUpdateUIEvent::IsCheckable() (Ian McInerney).
- Fix wxCaret default ctor (Stefan Brüns).
- Improve tooltips handling in wxPropertyGrid (Pavel Tyunin).
- Allow extending rules and zebra in wxListCtrl to the whole window (Marcos).
- Implement new coordinates conversion functions in wxDC (Artur Wieczorek).
- Improve high DPI handling in wxHtmlWindow (Maarten Bent).
- Improve selection/focus event generation in wxGenericListCtrl (Ali Kettab).
- Improve wxComboCtrl popup positioning (Oleksandra Yushchenka, Maarten Bent).
- Add wxRIBBON_ART_PANEL_HOVER_BORDER_[GRADIENT_]COLOUR (Gary Allen).
- Add wxRibbonToolBar GetToolByPos() and GetToolRect() (Gary Allen).
- Improve tooltips behaviour in wxRibbon (Gary Allen).
- Fix resorting wxDataViewCtrl with custom sort order (Jorge Moraleda).
- Make combining alignment and centering in wxSizerFlags work in wxGridSizer.
- Restore support for loading XRC files from URLs.
- Improve support for using default system locale.

wxGTK:

- Implement EGL-based wxGLCanvas for Wayland (Scott Talbert).
- Support Wayland in wxMediaCtrl (Pierluigi Passaro).
- Improve wxDataViewCtrl item insertion performance (Sebastien Besombes).
- Return more reasonable value from wxSlider::GetBetSize().
- Avoid pixman debug warnings in wxGrid.

wxMSW:

- Fix infinite repaint loop in wxListCtrl with wxLC_HRULES.
- Add real support for monochrome bitmaps to wxMSW (Bill Su).
- Allow customizing invalid wxDatePickerCtrl text.
- Allow using lower quality but faster pens.
- Fix best size of wxDatePickerCtrl with wxDP_ALLOWNONE.
- Fix build after STL changes in MSVS 2019 16.6
- Fix using JS in wxWebViewIE with custom scheme (Maarten Bent).
- Handle exception in wxEVT_CHAR_HOOK correctly.
- Improve high DPI support and custom scheme handlers in IE-based wxWebView (michael).
- Preserve ampersands in toolbar tool tooltips.
- Support Ctrl-Backspace in non-rich text controls too.

wxOSX:

- Add wxFullScreenEvent (Tobias Taschner).
- Add support for underline and strike-through in markup labels.
- Implement wxBitmap ctor from wxCursor (Igor Korot, Maarten Bent).
- Improve text controls focus ring appearance.
- Improve wxPreferencesEditor appearance under macOS 11.
- Significantly speed up wxDataViewCtrl::SetSelections().
- Fix window background tinting on macOS 11 (Václav Slavík).
- Fix cosmetic problem in wxSplitterWindow appearance (Andreas Falkenhahn).
- Fix bug with double clicking on empty space in wxDataViewCtrl (kurisutsukato).
- Fix handling of standard edit commands in context menu.
- Fix key events codes for non-ASCII characters (Artur Sochirca).
- Fix of accelerators defined in wxAcceleratorTable.
- Fix selection after inserting items in wxListBox (Andreas Falkenhahn).
- Fix system UI font handling on macOS 11.
- Fix truncation of images in wxDataViewCtrl (Andreas Falkenhahn).
- Fix wxDataViewCtrl columns resizing (Andreas Falkenhahn).
- Generate wxEVT_DATAVIEW_ITEM_EDITING_DONE in wxDataViewCtrl (Andreas Falkenhahn).
- Make setting tooltips for non-native windows work again.
- Make wxCOL_WIDTH_AUTOSIZE work correctly in wxDataViewCtrl (Andreas Falkenhahn).
- Mark wxTextCtrl as dirty before calling the event handler (Hartwig Wiesmann).
- Send wxEVT_TEXT when wxComboBox selection changes (Andreas Falkenhahn).
- Set and update wxListBox horizontal scrollbar correctly (Andreas Falkenhahn).
- Switch to WKWebView for wxWebView implementation (Tobias Taschner).

wxQt:

- Implement gesture events support (bdbcat).
- Implement wxMenuItem::SetFont() (bdbcat).


3.1.4: (released 2020-07-22)
----------------------------

INCOMPATIBLE CHANGES SINCE 3.1.3:

- CMake library targets were renamed and now start with 'wx'. In addition,
  aliases for the libraries have been added using the 'wx::' namespace. For
  example, the core library is now named wxcore and has alias wx::core.

- Building on ARM Apple platforms using configure now targets macOS by
  default, and not iOS. Please use --with-osx_iphone explicitly if you need
  the latter.


All:

- Add natural sort functions (Hugo Elias, PB).
- Add wxTempFFile class (Dummy).
- Fix bug with multiple leading ".." in wxFileName::Normalize() (Fabian Cenedese).
- Improve brush transparency support in wxSVGFileDC (Maarten Bent).
- Optionally forbid implicit wxString/char* conversions (Arrigo Marchiori).
- Add --disable-tests configure option (Hertatijanto Hartono).

All (GUI):

- Many wxGrid improvements:
  - Live-resize wxGrid columns/rows, making it work with wxGTK3 and wxOSX too.
  - Add activatable editors support, use it for boolean cells.
  - Add support for copying selected cells to clipboard (Kvaz1r).
  - Many bug fixes and usability improvements to selection.
  - Improve wxGridCellChoiceEditor usability (Ian McInerney).
  - Significantly optimize wxGrid::AutoSizeColumns() for big grids.
  - Add ellipsization support.
- Add support for wxGenericAnimationCtrl to XRC (Ilya Sinitsin).
- Add wxDD_SHOW_HIDDEN and wxDD_MULTIPLE wxDirDialog flags (Ian McInerney, PB).
- Add wxWebView::SetZoomFactor(float) (Hertatijanto Hartono).
- Add wxWindow::DisableFocusFromKeyboard() (Tomay).
- Allow overriding wxDataViewModal::HasValue() (Jorge Moraleda).
- Call wxAuiManager::UnInit() automatically now.
- Fix crash and layout problem in wxGenericDirCtrl (Maarten Bent).
- Improve AUI appearance in dark mode (Daniel Kulp, Michel Le Bihan).
- Upgrade libjpeg to 9d.
- Enable SIMD use in builtin PNG library (Maarten Bent).

wxGTK:

- Add native wxSearchCtrl implementation (AliKet).
- Several bug fixes and improvements in wxSpinCtrl.
- Implement wxBU_EXACTFIT support in wxButton (Artur Wieczorek).
- Allow using generic wxAnimationCtrl if wanted.
- Fix a regression with crashes when using wxBufferedPaintDC.
- Fix drawing bitmaps with masks using wxGraphicsContext under GTK2.
- Fix position of popup menus on non-primary display.
- Make wxUIActionSimulator much more reliable (AliKet).
- Fix caret colour in wxTextCtrl with custom colours.

wxMSW:

- Add Edge-based wxWebView backend (Tobias Taschner).
- Add wxUSE_DPI_AWARE_MANIFEST option (Maarten Bent).
- Add support for private fonts to Direct2D renderer (Artur Wieczorek).
- Adjust sizer borders on DPI change too (Maarten Bent).
- Allow showing only scalable fonts in wxFontDialog (Gilbert Pelletier).
- Fix building with gcc 10.1 in C++20 mode (PB).
- Fix flicker when resizing MDI frames (Richard Reznicek).
- Fix position of IME in wxSTC (wangqr).
- Fix wxWindow::Reparent() for TLWs (Danail Stoychev).
- Improve TAB handling in wxListBox (Artur Sochirca).
- Make CMake build using MinGW consistent with configure (Maarten Bent).
- Make wxDC::GetExtent() much faster (and a bit less precise).

wxOSX:

- Add support for macOS 11.
- Make wxOverlay work under macOS Mojave and later.
- Allow disabling automatic tabbing (Ian McInerney).
- Avoid duplicate key down events for Ctrl-O.
- Fix event generation, notably for mouse clicks, on wxStaticBitmap.
- Make shaped windows work again.
- Fix bugs in client size computation for some controls.
- Invalidate display cache when system configuration changes.
- Fix not showing more than 13 combobox items under 10.13+ (Dan Korn).
- Fix regression with child process IO redirection in 3.1.3.
- Fix regression with copying to clipboard in 3.1.3.
- Fix wxMediaCtrl::Seek() for sub-second resolution (Scott Talbert).
- Improve wxTextCtrl and wxSpinCtrl sizing (wangqr).
- Send EVT_MENU_HIGHLIGHT when menu items are unhighlighted (Ian McInerney).
- Stop including SDK headers from public wx headers (Lauri Nurmi).
- Support background colour in wxDataViewCtrl attributes (Ian McInerney).

wxiOS:

- Fix bundled libpng to not crash on iOS < 10.13 (maccy2).
- Implement wxMenu.

wxQt:

- Fix build with Qt 5.15 (Stefan Brüns).


3.1.3: (released 2019-10-28)
----------------------------

INCOMPATIBLE CHANGES SINCE 3.1.2:

- New wxTranslations::GetAcceptableTranslations() method was problematic and
  was removed, fixing various regressions in wxTranslations::AddCatalog() that
  were introduced by it. Thanks to Tomasz Słodkowicz and Dummy for reporting
  this and providing fixes for it.


All:

- Add C++20-style wxString::starts_with()/ends_with() functions (Lauri Nurmi).
- Add Croation translations (Milo Ivir).
- Add wxRegEx::QuoteMeta() (Tomay).
- Fix MIME type for wxFSFile obtained from wxHTTP.
- Support nullptr in wxPrintf() etc.
- Allow specifying optional libs in WX_CONFIG_CHECK (Juha Sointusalo).

All (GUI):

- Add support for freezing columns and/or rows in wxGrid (Lucian Rotariu)
- Fix wxInfoBar close button size in high DPI (Stefan Ziegler).
- Make disabling the window before creating it actually work.
- Implement wxAuiNotebook::GetBestSize() (Sebastian Walderich).
- Add support for editing dates (without time) to wxGrid (Pavel Kalugin).
- Allow changing tooltip text for button allowing to enter a new string
  in wxPGArrayEditorDialog.
- Fix wxPropertyGrid issues with horizontal scrolling.
- Add wxPG_DIALOG_TITLE wxPGProperty attribute.
- Add support for creating a wxGraphicsPen with a gradient.
- Add support for applying a transformation matrix to a gradient.
- Fix and unify drawing wxBitmap with both alpha channel and mask under all platforms.
- Improve AUI notebook appearance in high DPI (Paul Kulchenko).
- Add XRC handler for wxDataViewCtrl (Anton Triest).
- Add XRC handler for wxInfoBar (Илья Синицын).
- Add support for checkboxes to virtual wxListCtrl too (Maarten Bent).
- Add wxBusyInfo::Update{Text,Label}() (Kvaz1r).
- Add wxDCTextBgColourChanger and wxDCTextBgModeChanger (Vsevolod V Gromov).
- Add wxFD_SHOW_HIDDEN flag to wxFileDialog (Igor Korot).
- Add wxRendererNative::DrawCheckMark() (Maarten Bent).
- Add wxSystemAppearance, notably useful for macOS dark mode checks.
- Allow expanding environment variables in XRC file paths (ousnius).
- Enhance support for underlining in wxTextCtrl.
- Fix spurious asserts in wxBoxSizer when wxSHAPED is used.
- Fix wxWrapSizer minimum size calculations (Илья Синицын).
- Improve popups appearance and behaviour in wxSTC (New Pagodi).
- Improve wxHtmlWindow selection appearance and behaviour (Павел Калугин).

wxGTK:

- Invalidate selection after deleting wxListBox item with GTK+ 3 too.
- Add support for ticks to wxSlider (Iwbnwif Yiw).
- Fix two-finger scrolling under Wayland (Scott Talbert).
- Fix wxEVT_KEY_DOWN for non-ASCII characters (Scott Talbert).
- Fix crash in wxDataViewTreeCtrl::DeleteAllItems().
- Make wxDataViewModel::Cleared() behave consistently with the other ports.
- Fix best size computation for multiline wxTextCtrl.
- Fix best size computation for wxGauge (Iwbnwif Yiw).

wxMSW:

- Add support for per-monitor DPI under new enough OS versions (Maarten Bent).
- Add MSVS 2019 support.
- Fix passing Unicode strings via wxIPC when using DDE.
- Improve wxDataViewCtrl performance with variable line heights (Jens Goepfert).
- Add EVT_COLOURPICKER_CURRENT_CHANGED (Trylz).
- Fix linking of monolithic library with MinGW (Jannick).
- Support fill mode in GDI+ and D2D graphics contexts (Maarten Bent).
- Add wxFileDialog::GetCurrentlySelectedFilterIndex() (QuentinC).
- Add wxPU_CONTAINS_CONTROLS style for popups (New Pagodi).
- Add wxWebViewIE::MSWSetEmulationLevel() (Chilau He).
- Allow showing ToC/search in wxCHMHelpController (Andreas Falkenhahn)
- Fix RegisterHotKey() work with WXK_XXX.
- Fix changing wxSpinCtrl colours (Kvaz1r).
- Fix compilation in deprecated ANSI build mode.
- Fix drawing cross hair on wxDC.
- Fix input handling bugs in text controls with autocompleters.
- Fix pasting very long strings into wxTextCtrl.
- Fix resetting columns images in wxListCtrl (followait).
- Optimize drawing solid vertical and horizontal lines on wxDC
- Recognize UTF-8 system encoding supported in latest MSW 10 versions.
- Work around nVidia bug with OpenGL and coloured buttons.
- Handle Ctrl+A in focused wxTextCtrl instead of always as an accelerator.

wxOSX:

- Support for macOS Mojave and later dark mode.
- Fix crash in wxGauge with wxGA_PROGRESS (Konstantin Matveyev).
- Fix crash when pasting from clipboard (Tim Kosse).
- Fix dragging files (Dan Gudmundsson).
- Fix fetching sub-bitmap from wxBitmap with maskAll
- Fix wxPOPUP_WINDOW style (Dan Korn).
- Make it possible to play wxSound again (frustum).
- Allow setting focus before showing the window.
- Fix order of accelerators handling, giving priority to focused window.
- Don't stop TAB navigation on wxRadioBox when full keyboard access is off.

wxQt:

- Too many changes to list. Thanks to Graham Dawes, Jay Nabonne, Matthew
  Griffin, Liam Treacy, Chris Lemin, Cătălin Răceanu, Richard Smith, Mick
  Waites and others.


3.1.2: (released 2018-12-10)
----------------------------

All:

- Add wxLZMA{Input,Output}Stream classes using external liblzma.
- Make wxList and wxVector iterators conform to input iterator requirements.
- Fix MT-safety problem when reading and writing from wxSocket (jkubalik).
- Fix build issues under HaikuOS (mill-j).
- Fix problem with wx-config installation and use under NetBSD (wiz).
- Avoid spurious errors on thread creation under NetBSD.
- Improve high DPI support in wxAui (Simon Rozman).
- Fix a bug with parsing time zones in wxDateTime::ParseFormat() (evileye).
- Update all 3rd party libraries to their latest versions (Maarten Bent).

All (GUI):

- wxAdvanced library was merged into wxCore, simply remove all references
  to "adv" from your build system, it is not needed any longer.
- Add support for non-integer font sizes (e.g. 10.5pt fonts).
- Add support for font weights in 1..1000 interval and not just light/bold.
- Add wxDataViewToggleRenderer::ShowAsRadio().
- Improve stock items consistency and aesthetics (dhowland).
- Fix bug with missing items in overflowing AUI toolbar (Maarten Bent).
- Revert to left-aligning wxSpinCtrl contents by default.
- Make wxRibbonButtonBar buttons more customizable (Max Maisel).
- Add wxHtmlEasyPrinting::SetPromptMode() (pavel-t).
- Fix possible infinite loop in wxHtmlWindow layout (trivia21).
- Add "hint" property support to XRC for wxComboBox and wxSearchCtrl.
- Add support for style="page-break-inside:avoid" to <div> in wxHTML.
- Support strike-through in wxDataViewItem attributes (approach, Igor Korot).
- Allow distinguishing between user- and script-opened windows in wxWebView.
- Allow binding to events generated by their items in submenus too.
- Add wxGrid::SetCornerLabelValue() (Pavel Kalugin).
- Add strikethrough support for fonts defined in XRC.
- Add wxDisplay::GetPPI().
- Add wxJoystickEvent::GetButtonOrdinal() (Mick Phillips).
- Add wxGraphicsContext::GetWindow() and implement wxGraphicsContext::GetDPI().
- Add wxToolbook::EnablePage() (Stefan Ziegler).
- Adapt AUI colours to system colour changes (Daniel Kulp).
- Fix removing and inserting pages in wxToolbook (Stefan Ziegler).
- Fix bug in template selection in docview framework (jwiesemann).
- Implement wxAuiNotebook::HitTest() (Sebastian Walderich).

wxGTK:

- Implement wxTextCtrl::HitTest() for single line controls.
- Fix bug with wxTextCtrl::ChangeValue("") sending an unwanted event.
- Implement wxDataViewColumn::UnsetAsSortKey().
- Fix not showing wxInfoBar with GTK+ 3 < 3.22.29.
- Fix the build with glib < 2.32 (e.g. CentOS 6).
- Fix field widths in wxStatusBar showing a size grip.
- Fill column value in wxEVT_DATAVIEW_ITEM_ACTIVATED events.
- Implement wxDataViewCtrl::GetItemRect() (MrMeesek).

wxMSW:

- Add experimental support for Windows 10/ARM64 platform (Simon Rozman).
- Fix hang after clearing wxTAB_TRAVERSAL style on a window with children.
- Fix handling of AUX2 mouse button events (Timon Rozmanrylz).
- Implement support for more than 4 joystick buttons (Mick Phillips).
- Fix saving/restoring window position for maximized windows.
- Fix stack corruption when using wxStackWalker (srfisk).
- Fix positioning windows at positions >= SHORT_MAX (Cătălin Răceanu).
- Honour alignment flags for multiline buttons using custom colours too.
- Support MSVC auto-linking when using monolithic build too (PB).
- Implement wxFontDialog::SetTitle() (Vitaly Stakhovsky).
- Fix build in ANSI (non-Unicode) mode.
- Improve wxNotebook themed background drawing (Arrigo Marchiori).
- Send wxEVT_WEBVIEW_NAVIGATING when redirecting (Josue Andrade Gomes).
- Fix build with MSVS 2005 broken in 3.1.1.
- Add wxwidgets.props property sheet file for MSVS users.
- Fix jumping to the given position in wxMediaCtrl (ashishmore).

wxOSX:

- Fix dispatching pending events (and CallAfter()) in console applications.
- Implement wxDataViewColumn::UnsetAsSortKey() (Daniel Kulp).
- Change wxBitmap to use native image format like NSImage and UIImage.
- Implement wxStaticBitmap natively for correct rendering of template images.
- Fill column value in wxEVT_DATAVIEW_ITEM_ACTIVATED events (Igor Korot).
- Make wxFrame::EnableFullScreenView() work under macOS 10.11+ (Andy Robinson).

wxQt:

- Fix menu bar background colour (Naser Buhamad).
- Add support for bitmaps in menu items (Igor Korot).


3.1.1: (released 2018-02-19)
----------------------------

INCOMPATIBLE CHANGES SINCE 3.1.0:

- wxListCtrl::HasCheckboxes() and EnableCheckboxes(), which were added in
  3.1.0, have been renamed to HasCheckBoxes and EnableCheckBoxes respectively
  for consistency with wxCheckBox naming.

- The enum value wxTASKBAR_JUMP_LIST_DESTIONATION, which was added in 3.1.0,
  contains a typo and has been renamed to wxTASKBAR_JUMP_LIST_DESTINATION.

- wxZipOutputStream will now automatically convert filenames to UTF-8, if the
  wxMBConv used when calling the constructor supports UTF-8 encoding.


All:

- Add CMake-based build system (Tobias Taschner).
- Add wxSecretStore for storing passwords using the OS-provided facilities.
- Add support for compiling application code with wxNO_UNSAFE_WXSTRING_CONV.
- Add support for translating strings in different contexts (RickS).
- Add wxDateTime::GetFirstWeekDay() (Lauri Nurmi).
- Add support for the micro version (third component) to OS and toolkit version
  functions. See wxGetOsVersion(), wxPlatformInfo, and wxAppTraits.
- wxLogInfo() now logs messages if the log level is high enough, even without
  wxLog::SetVerbose() which now only affects wxLogVerbose().
- Add wxFileType::GetExpandedCommand() (troelsk).
- Make it easier to convert to/from UTF-8-encoded std::string (ARATA Mizuki).
- Support custom conversions in wxLogStream and wxLogStderr (Lauri Nurmi).
- Add support for loading dynamic lexer in wxStyledTextCtrl (New Pagodi).
- Handle strings with embedded NULs in wxDataStream (Nitch).
- Don't crash in wxTextFile::GetLastLine() if the file is empty (crohr).
- Add wxString::cbegin() and cend() method (Lauri Nurmi).
- Allow using Bind() with event handlers non-publicly deriving from
  wxEvtHandler and/or wxTrackable in C++11 code (Raul Tambre, mmarsan).
- Update bundled expat to 2.2.0 (Catalin Raceanu).
- Add wxCMD_LINE_HIDDEN wxCmdLineParser flag (Lauri Nurmi).
- Fix wxRmdir() with non-ASCII paths (trivia21).
- Don't crash in wxFFile::Eof() or Error() on closed file (jprotopopov).
- Add UTF-8 support to wxZipOutputStream (Tobias Taschner).
- Update all bundled 3rd party libraries to their latest versions.
- Use unique prefix for all zlib symbols to avoid link conflicts.
- Make wxFile::ReadAll() work for unseekable files too.
- Correct UTF-8 encoding of U+FFFF (axiom).

All (GUI):

- Allow wxWebView::RunScript() return values (Jose Lorenzo, GSoC 2017).
- Allow using fractional pen widths with wxGraphicsContext (Adrien Tétar).
- Add support for loading fonts from external files (Arthur Norman).
- Add support for using arbitrary windows as wxStaticBox labels.
- Improve wxSVGFileDC to support more of wxDC API (Maarten Bent).
- Add support for wxAuiManager and wxAuiPaneInfo to XRC (Andrea Zanellato).
- Add XRC handler for wxSpinCtrlDouble (Trylz).
- Add support for wxSL_MIN_MAX_LABELS and wxSL_VALUE_LABEL to XRC (ousnius).
- Update Scintilla to v3.7.2 (NewPagodi, Paul Kulchenko).
- Update bundled libpng to 1.6.28 (Catalin Raceanu).
- Automatically determine first day of the week in wxCalendarCtrl (Lauri Nurmi).
- Fix vertical scrollbar visibility in wxStyledTextCtrl (yenwu, NewPagodi).
- Fix bug with not being able to select AUI tab after dragging.
- Make wxDataViewCtrl::Expand() expand ancestors in native ports too.
- Add wxDataViewTextRenderer::EnableMarkup().
- Add wxDataViewCtrl::SetHeaderAttr().
- Add wxDataViewCtrl::GetTopItem() and GetCountPerPage() (Andreas Falkenhahn).
- Add wxListCtrl::SetHeaderAttr().
- Add support for using markup in wxDataViewCtrl text items.
- Implement auto complete in generic wxSearchCtrl (Eric Jensen).
- Fix preserving selection when changing selection mode in wxGrid (jonkraber).
- Fix wxTextEntry::SetHint() with wxTE_PASSWORD in generic implementation.
- Many fixes and improvements in Direct2D, Cairo, and GDI+ graphics renderers.
- Fix and unify clipping region support for MSW and GTK+.
- Fix rescaling of wxImage.
- Fix displaying edited value of wxUIntProperty (wxPropertyGrid).
- Fix displaying validation errors for numeric wxPropertyGrid properties.
- Add wxSYS_CARET_{ON,OFF,TIMEOUT}_MSEC system settings (brawer).
- Add wxGraphicsContext::GetClipBox().
- Fix wxGCDC::Clear() for rotated graphics context.
- Fix wxGCDC::GetClippingBox() for transformed wxDC.
- Add support for affine transformation matrix in wxGCDC.
- Add wxGraphicsContext::Flush() for Cairo renderer.
- Add wxStyledTextEvent::GetListCompletionMethod() (NewPagodi).
- Add wxEVT_STC_AUTOCOMP_COMPLETED event (NewPagodi).
- Fix retrieving bounding box for wxDC with transformed coordinates.
- Fix wxGraphicsMatrixData::Concat() for Direct2D and Cairo renderers.
- Fix calculating point position in wxDataViewCtrl::HitTest().
- Fix position of the rectangle returned by wxDataViewCtrl::GetItemRect().
- Add wxDataViewRenderer::GetAccessibleDescription().
- Add wxDataViewCheckIconTextRenderer class.
- Implement persistence support for wxDataViewCtrl (iwbnwif).
- Improve wxImage::Scale() handling of pixels with alpha channel (Tim Kosse).
- Fix parsing of RGBA strings in wxColour (Laurent Poujoulat).
- Refactor code in wxQuantize() for MSVC to avoid crash.
- Fix drawing rotated and/or underlined text on wxPostScriptDC.
- Support multiline strings in wxPostScriptDC::DrawText(), DrawRotatedText().
- Deprecate wxEVT_STC_KEY and wxEVT_STC_URIDROPPED events (NewPagodi).
- Optimize font registration in PostScript code emitted by wxPostScriptDC.
- Fix drawing filled arc with wxPostScriptDC::DrawArc().
- Optimize PostScript code emitted by wxPostScriptDC to draw elliptic arcs.
- Add wxStyledTextCtrl::AutoCompGetCurrentText() (NewPagodi).
- Extend wxStyledTextCtrl::FindText() to return end position of matched
  text (NewPagodi).
- Fix adding/removing items to/from wxRearrangeList.
- Handle wxST_ELLIPSIZE_XXX styles in wxStaticText XRC handler (tm).
- Add support for bitmaps to wxToggleButton XRC handler (tm).
- Fix wxGCDC::SetDeviceClippingRegion().
- Never restore size smaller than the best one in wxPersistentTLW.
- Fix escaping/unescaping characters in wxLongStringProperty in wxPG (mikek).
- Ensure that navigation order reflects layout of wxStdDialogButtonSizer.
- Add Scintilla FineTicker methods to wxSTC (NewPagodi).
- Add wxFontPickerCtrl::SetMinPointSize() (Andreas Falkenhahn).
- Add Set/GetFooter/Text/Icon() to wxRichMessageDialog (Tobias Taschner)
- Add wxFloatingPointValidator::SetFactor().
- Add "hint" property to wxSearchCtrl XRC handler.
- Add wxEVT_SEARCH[_CANCEL] synonyms for wxSearchCtrl events.
- Generate wxEVT_SEARCH on Enter under all platforms.
- Extend wxRendererNative::DrawGauge() to work for vertical gauges too.
- Add wxHD_BITMAP_ON_RIGHT style to wxHeaderCtrl.
- Send wxEVT_DATAVIEW_ITEM_EDITING_DONE when editing was cancelled too.
- Add wxIMAGE_OPTION_GIF_TRANSPARENCY (Hugo Elias).

wxGTK:

- Make wxUIActionSimulator work with GTK+ 3 (Scott Talbert).
- Make wxBORDER_NONE work for wxTextCtrl with GTK+ 3 (Adrien Tétar).
- Handle wxTE_PROCESS_TAB, and its absence, correctly in multiline wxTextCtrl.
- Apply wxTextCtrl::SetDefaultStyle() to user-entered text (Andreas Falkenhahn).
- Implement dynamic auto-completion in wxTextEntry (AliKet).
- Fix wxTextCtrl::GetStyle() with GTK+ 3.
- Fix wxButton::SetBitmapPosition() with GTK+ 3 (Jake Nelson).
- Support background colour in wxDataViewCtrl attributes.
- Fix regression with showing custom wxDataViewCtrl editors.
- Improve wxSpinCtrl best size calculation.
- Implement support for icon locations in wxMimeTypesManager (Hanmac).
- Improve wxRadioBox appearance in high DPI (Arrigo Marchiori, Maarten Bent).
- Cosmetic fix for empty wxCheckBoxes display (Chuddah).
- Fix crashes in wxFileSystemWatcher implementation (David Hart).
- Fix wxBitmap ctor from XBM for non-square bitmaps.
- Fix wxDC::GetClippingBox() for transformed wxDC.
- Add support for affine transformation matrix in wxDC (GTK+ 3).
- Fix wxMemoryDC::Blit() with itself as source (GTK+ 3).
- Fix displaying labels of wxRadioBox items.
- Add a native implementation for clearing bitmap/window wxGraphicsContexts
- Implement XYToPosition() for single-line wxTextCtrl.
- Implement ShowPosition() for single-line wxTextCtrl.
- Improve wx{Client,Paint,Screen,Window}DC::GetPPI() (GTK+ 3).
- Suppress focus loss events for wxChoice and wxComboBox on opening popup.
- Make custom URI schemes work WebKit2-based wxWebView (Scott Talbert).

wxMSW:

- Add support for building with Microsoft Visual Studio 2017 (Tobias Taschner).
- Allow loading icons from resources in wxIconBundle (PB).
- Enable wxStackWalker in MinGW64 builds.
- Fix build under Cygwin in 64 bits.
- Fix crash when using wxCHMHelpController() in 64 bit builds (Xlord2).
- Fix wxSpinCtrl appearance: show arrows inside the control (Catalin Raceanu).
- Fix MDI menu display after failure to create a child frame (troelsk).
- Fix wxScreenDC::GetSize() with multiple monitors (iwbnwif).
- Fix background colour returned by wxTextCtrl::GetStyle() (Andreas Falkenhahn).
- Revert to using equally-sized buttons in wxToolBar by default.
- Fix default button highlighting.
- Restore dispatching wxThreadEvent while resizing the window broken in 3.1.0.
- Fix wxGraphicsMatrix::TransformDistance for Direct2D renderer.
- Fix wxDC::Clear() for rotated DC.
- Fix wxDC::GetClippingBox() for transformed wxDC.
- Fix wxMemoryDC::Blit() with itself as source (Tim Roberts).
- Return proper value from wxIAccessible::get_accSelection() if no children
  are selected.
- Add wxAccStatus::wxACC_INVALID_ARG error code to indicate argument-related
  errors in wxAccessible methods.
- Return DISP_E_MEMBERNOTFOUND error code from wxIAccessible if wxAccessible
  methods return wxAccStatus::wxACC_NOT_SUPPORTED.
- Return null BSTR from wxIAccessible if string returned from wxAccesible
  method is empty.
- Handle Ctrl-A in non-rich multiline text controls (Jens Göpfert).
- Use cairo_win32_surface_create_with_format() to create ARGB surface from
  wxMemoryDC (Cairo >= 1.15.4).
- Fix updating bounding box in wxDC::DrawSpline().
- Fix placing 0RGB wxBitmaps on the clipboard.
- Fix handling wxClipboard data when wxUSE_OLE == 0.
- Fix caching of wxFONTSTYLE_SLANT fonts in wxTheFontList.
- Fix wxTextCtrl::XYToPosition() and PositionToXY().
- Fix updating radio groups when non-radio item is inserted to wxMenu.
- Fix autoselecting the contents of wxTextCtrl with wxWANTS_CHARS style.
- Implement SetIcon(), SetPosition(), GetPosition() for native wxProgressDialog.
- Fix focus-related problems when using native wxProgressDialog.
- Fix crash when reparenting the currently focused window to another TLW.
- Fix sending wxEVT_TEXT_ENTER when using auto-completion (Dubby).
- Fix missing selection event on click in multiselection wxDataViewCtrl (mikek).

wxOSX:

- Many fixes for tab navigation (ikamakj).
- Fix handling of non-BMP characters in GetPartialTextExtents() (ARATA Mizuki).
- Fix setting foreground colour for several controls (Steve Browne).
- Fix dialogs using wxFRAME_FLOAT_ON_PARENT frame as parent (Lauri Nurmi).
- Implement wxGetDisplaySizeMM() and fix printing DPI (David Vanderson).
- Remove extra borders around wxFilePickerCtrl (John Roberts).
- Set up extensions filter correctly in wxFileDialog (nick863).
- Implement wxDataViewChoiceByIndexRenderer (wanup).
- Fix unnecessary indentation in list-like wxDataViewCtrl (Andreas Falkenhahn).
- Recognize macOS 10.12 Sierra in wxGetOsDescription() (Tobias Taschner).
- Don't try to open command line arguments as files (Jeff Hostetler).
- Implement wxDataViewCtrl::SetRowHeight().
- Add OSXEnableAutomaticQuoteSubstitution(), OSXEnableAutomaticDashSubstitution()
  and OSXDisableAllSmartSubstitutions() to control wxTextCtrl smart behavior.
- Don't allow interacting with disabled wxSlider (Andreas Falkenhahn).
- Fix setting alignment in wxTextCtrl with wxTE_DONTWRAP (Andreas Falkenhahn).
- Allow pasting using Cmd+V in wxTextCtrl with wxTE_PASSWORD style.
- Update font code to use toll-free bridges from CTFontRef to NSFont or UIFont
- Add a native implementation for clearing bitmap/window wxGraphicsContexts
- wxiOS now needs a minimum of iOS 9 for deployment
- Fix handling CTM in wxGraphicsContext::SeTransform and GetTransform().
- Allow turning on/off opacity selector in wxColourDialog.
- Implement wxTextCtrl::PositionToXY() and XYToPosition().
- Implement wxTextCtrl::ShowPosition().
- Add support for wxTE_NO_VSCROLL style to wxTextCtrl.
- Add support for wxTE_CHARWRAP style to wxTextCtrl.
- Fix selecting RGB bitmaps (with no alpha channel) into wxMemoryDC.
- Fix updating radio groups when menu item is inserted/removed from wxMenu.
- Allow changing alignment styles after wxTextCtrl creation (Andreas Falkenhahn).
- Fix wxDataViewColumn::SetSortOrder() (hartwigw).

wxQt

- Many changes and improvements by Sean D'Epagnier merged into trunk (with
  help from R.J.V. Bertin).

Unix:

- Support new gstreamer API in 1.7.2+ in wxMediaCtrl (Sebastian Dröge).
- Add wxStandardPaths::SetFileLayout(FileLayout_XDG) (Martin Koegler).


3.1.0: (released 2016-02-29)
----------------------------

- Many improvements for high DPI monitors support, notably XRC now interprets
  all pixel values as being in resolution-independent pixels.

- wxQt branch implementing Qt5-based port of wxWidgets API was merged into
  the trunk (Mariano Reingart, Google Summer of Code project).

- Added wxNativeWindow allowing to embed native widgets in wxWidgets programs.

- Improve wxGLCanvas to be more type safe and better support modern OpenGL.

All:

- Add UTF-8 and ZIP 64 support to wxZip{Input,Output}Stream (Tobias Taschner).
- Upgrade libpng to 1.6.21 fixing several security bugs (Paul Kulchenko).
- Support gstreamer 0.10 and 1.0 in wxMediaCtrl (Sebastian Dröge).
- Fix handling of Unicode file names in wxFileSystem::FindFirst().
- Add wxStandardPaths::GetUserDir() (Tobias Taschner).
- Allow calling wxItemContainer::Add() and similar with std::vector<> argument.
- Add "%z" support to printf()-like functions like wxString::Format() (RIVDSL).
- Add DOCTYPE support to wxXmlDocument (Nick Matthews).
- Add wxPowerResourceBlocker (Tobias Taschner).
- Add wxApp::StoreCurrentException() and RethrowStoredException() and implement
  their functionality by default when using C++11 compiler.
- Allow iterating over wxCmdLineParser arguments in order (Armel Asselin).
- Add wxScopedArray ctor taking the number of elements to allocate.
- Add wxDynamicLibrary::GetModuleFromAddress() (Luca Bacci).
- Implement wxThread::SetPriority() for pthreads (Luca Bacci).
- Add wxInt64 support to wxText{Input,Output}Stream (Alexander Bezzubikov).
- Define wxOVERRIDE as override for supporting compilers (Thomas Goyne).
- Allow specifying custom comparator for wxSortedArrayString (Catalin Raceanu).
- Add wxDateTime::GetWeekBasedYear().
- Specialize std::hash<> for wxString when using C++11.
- Allow recursive calls to wxYield().
- Add wxART_FULL_SCREEN standard bitmap (Igor Korot).
- Fix wxStringTokenizer copy ctor and assignment operator.
- Added wxASSERT_MSG_AT() and wxFAIL_MSG_AT() macros.
- Accept replacement character in wxString::ToAscii() (Stefano D. Mtangoo).

Unix:

- Fix bug in wxExecute() if child exited too quickly (Kevin B. McCarty).
- Add --disable-sys-libs configure option.
- Add --enable-cxx11 configure option.

All (GUI):

- Allow requesting modern (3.x+) OpenGL version in wxGLCanvas (Fabio Arnold).
- Add wxActivityIndicator.
- Add wxWindow::FromDIP() for simpler high DPI support.
- Allow initially hiding sizer items in XRC (Bogdan Iordanescu).
- Allow customizing window shown by wxBusyInfo.
- Add wxAddRemoveCtrl.
- Add wxAppProgressIndicator for MSW (Chaobin Zhang) and OS X (Tobias Taschner).
- Add support for using checkboxes to wxListCtrl (Maarten Bent).
- Add wxListBox::GetTopItem() and GetCountPerPage() (Andreas Falkenhahn).
- Add wxTextEntry::ForceUpper().
- Add wxTextEntryDialog::ForceUpper().
- Add wxEVT_MAGNIFY mouse event (Joost Nieuwenhuijse).
- Add wxProcess::Activate().
- Fix setting colours of labels in wxSlider.
- Fix setting background colour of wxRadioBox buttons.
- Add wxTopLevelWindow::Enable{Maximize,Minimize}Button() (John Roberts).
- Make results of wxDC::DrawEllipticArc() consistent across all platforms.
- XRC handler for wxAuiToolBar added (Kinaou Hervé, David Hart).
- Improve wxLIST_AUTOSIZE_XXX support in generic wxListCtrl (Kinaou Hervé).
- Support "color", "size" and "font" CSS for fonts in wxHTML (Kinaou Hervé).
- Fix one pixel gaps between consecutive underlined words in wxHTML.
- Add wxCursor::GetHotSpot().
- Add wxFD_NO_FOLLOW style for wxFileDialog (Luca Bacci).
- Add support for embedding bitmaps in generated SVG in wxSVGFileDC (iwbnwif).
- Add support for sorting wxDataViewCtrl by multiple columns (Trigve).
- Allow dropping data on wxDataViewCtrl background (Laurent Poujoulat).
- Add wxRendererNative::DrawGauge() (Tobias Taschner).
- Add wxRendererNative::DrawItemText() (Tobias Taschner).
- Add wxHtmlWindow::SetDefaultHTMLCursor() (Jeff A. Marr).
- Add default ctor and Create() to wxContextHelpButton (Hanmac).
- Send events when toggling wxPropertyGrid nodes from keyboard (Armel Asselin).
- Fix wxRearrangeList::Check() which asserted and misbehaved before.
- Optimized wxRTC insertion and deletion when floating objects are present.
- Added on-demand image loading option to wxRTC.
- Add wxFont::GetBaseFont() (Melroy Tellis).
- Update Scintilla to v3.5.5 (Christian Walther, Heyoupeng, ARATA Mizuki).
- Add wxStyledTextCtrl copy/paste text events (Christian Walther).
- Improve RTL support in wxStyledTextCtrl (Zane U. Ji).
- Add support for loading old V1 BMP files to wxImage (Artur Wieczorek).
- Improve auto sizing of wrapped cells in wxGrid (iwbnwif).
- Fix handling of rectangular selections in wxStyledTextCtrl (roberto).
- Fix characters outside of the BMP in wxStyledTextCtrl (Thomas Goyne).
- Allow access to the currently shown wxInfoBar buttons (Hanmac).
- Add wxGenericListCtrl::EndEditLabel() (Tim Kosse).
- Use native renderer for drawing check boxes in wxPropertyGrid (Eran Ifrah).
- Fix drawing custom colours of wxEnumProperty items in wxPG (Artur Wieczorek).
- Add wxBitmap ctor from wxCursor.
- Always disable wxWizard "Back" button on the starting page (pmgrace30).
- Add wxUIActionSimulator::Select().
- Add wxOwnerDrawnComboBox::Is{List,Text}Empty() methods.
- Fix creating/removing mode buttons in wxPG manager (Artur Wieczorek).
- Harmonize wxMenuEvent handling between all major ports.
- Fix wxPGChoices copy ctor (Snoits).
- Show how to handle files on command line in docview sample (Neil Mayhew).
- Improve wxFileCtrl::SetFilename() and SetPath() (Kevin B. McCarty).
- Fix a crash when using animated GIFs in wxHtmlListBox.
- Use platform-specific stock icons for wxEditableListBox buttons.
- Add support for the events from multimedia keys (Jens Göpfert).
- Allow suppressing warnings from wxImage::LoadFile().
- Allow customizing wxRibbon highlight colours (wxBen).
- Enable selecting opacity in generic wxColourPicker.
- Extend the support for font weights to a bigger range.
- Add support for fractional font sizes.

wxGTK:

- Support building wxGTK3 under Windows (Kolya Kosenko).
- Implement support for non-wxTextCtrl custom editors in wxDataViewCtrl.
- Fix vertical cell alignment in wxDataViewCtrl.
- Fix clearing of wxComboBox with wxCB_READONLY (Chuddah).
- Fix setting "pressed" bitmap for wxToggleButton (Kevin B. McCarty).
- Fix GTK+ warnings for wxFileDialog with wxFD_MULTIPLE style.
- Don't generate wxEVT_LIST_ITEM_RIGHT_CLICK outside of item area (Igor Korot).
- Implement wxDataViewCtrl::SetIndent().

wxMSW:

- Make default wxSizer border DPI-aware.
- Implement native appearance for wxAUI tabs and toolbars (Tobias Taschner).
- Show more modern-looking wxNotificationMessages under 8+ (Tobias Taschner).
- Improve wxMimeTypesManager open command detection (Eric Jensen).
- Make wxFILTER_INCLUDE_LIST in wxTextValidator actually usable.
- Fix handling crashes in wxEVT_PAINT event handlers.
- Fix wxStackWalker to work with Unicode identifiers (Suzumizaki-kimitaka).
- Fix appearance of toggled wxToggleButtons with bitmap (tm).
- Fix setting menu item bitmaps after appending them (Artur Wieczorek).
- Fix setting label of submenu items (Artur Wieczorek).
- Fix handling of selected images in wxBitmapButton (Artur Wieczorek).
- Fix loading of bitmap with non-pre-multiplied alpha (Artur Wieczorek).
- Support multiline strings in wxDC::DrawRotatedText() (Artur Wieczorek).
- Fix stretchable spacers in vertical toolbars (Artur Wieczorek).
- Implement setting foreground colour for wxRadioButton (Artur Wieczorek).
- Add font colour support to wxFontPickerCtrl (Pana Alexandru).
- Add wxEnhMetaFile::Detach() (Luca Bacci).
- Add support for saving 256*256 32bpp ICOs in PNG format (Artur Wieczorek).
- Keep menu item icon after removing and adding it back (Artur Wieczorek).
- Add wxThread::MSWGetHandle() (troelsk).
- Allow using sizers for laying out wxMDIClientWindow (Artur Wieczorek).
- Fix updating wxSlider background when its parent background changes.
- Implement wxListBox::EnsureVisible() (RIVDSL).
- Drastically improve efficiency of selecting all items in wxDataViewCtrl.
- Fix spurious selection events generation in wxDataViewCtrl.
- Fix wxMenuEvent::GetMenu() for wxEVT_MENU_{OPEN,CLOSE} in MDI frames.
- Fix updating wxSpinCtrlDouble tooltip text (Laurent Poujoulat).
- Fix appearance of checked disabled wxToolBar tools with custom images.
- Fix reading of not NUL-terminated strings using wxRegKey (Steffen Olszewski).
- Fix unexpected change in MDI children order after showing a file dialog.
- Don't send events for already selected radio popup menu items (Kinaou Hervé).
- wxListCtrl::GetItemCount() in wxEVT_LIST_INSERT_ITEM is no longer off by 1.
- Don't send bogus root selection events when clicking wxTreeCtrl (sbrowne).
- Avoid bogus assert after calling wxDatePickerCtrl::SetRange().
- Add solution file for building with MSVS 2014 (Peter Tissen).
- Correct wxGetOsDescription() for Windows 10 (Tobias Taschner).
- Make wxListCtrl &c appearance more native on modern systems (Tobias Taschner).
- Don't send wxActivateEvent for minimized windows (bzcdr).
- Return correct OS version under Windows 8.1 and later.
- Fix crash in wxD2DContext when using non-MSVC compiler (iwbnwif).
- Notify shell about the changes done by wxMimeTypesManager (Maarten Bent).
- Fix wxPrintf() and friends when using MinGW with ANSI stdio option.
- Fix strike-through support in wxFont with GDI+ (David Vanderson).
- Fix UTF-32 conversion for non-BMP characters (ARATA Mizuki).
- Use correct parent for the native modal dialogs (Andreas Falkenhahn).
- Fix layout of wxSlider with wxSL_VALUE_LABEL only (gafatoa).
- Fix flicker when resizing columns of report-mode wxListCtrl.
- Implement wxTreeCtrl::SetDoubleBuffered() (Steve Browne).

wxOSX/Cocoa:

- Make wxiOS (iPhone) port build and minimally work again (Tobias Taschner).
- Use more efficient FSEvents in wxFileSystemWatcher (Roberto Perpuly).
- Implement wxWindow::Disable() for non-native controls too (Steve Browne).
- Implement wxTopLevelWindow::EnableCloseButton() (John Roberts).
- Fix wxEVT_CHAR for non-BMP Unicode characters (ARATA Mizuki).
- Add wxTE_AUTO_URL support to wxTextCtrl (Igor Korot).
- Add support for wxEVT_COMBOBOX_{DROPDOWN, CLOSEUP} events (Igor Korot).
- Implement strike-through support in wxFont (Igor Korot, Daniel Kulp).
- Provide native implementation of wxStandardPaths (Tobias Taschner).
- Add wxTE_{RIGHT,CENTER} support for multiline wxTextCtrl (Andreas Falkenhahn).
- Don't leave wxSlider labels shown when the slider itself is hidden.
- Don't generate wxEVT_TEXT_ENTER for controls without wxTE_PROCESS_ENTER.
- Implement wxToolTip::SetDelay() (David Vanderson).
- Correct positioning of popup menus relative to mouse pointer (John Roberts).
- Add support for right-aligned checkboxes (John Roberts).
